/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ACT_ACCEPT = 258,
     ACT_REJECT = 259,
     ACT_TEMPFAIL = 260,
     ACT_CONTINUE = 261,
     ACT_DISCARD = 262,
     ADD = 263,
     REPLACE = 264,
     DELETE = 265,
     PROG = 266,
     IF = 267,
     FI = 268,
     ELSE = 269,
     ELIF = 270,
     ON = 271,
     HOST = 272,
     FOR = 273,
     FROM = 274,
     AS = 275,
     DO = 276,
     DONE = 277,
     POLL = 278,
     MATCHES = 279,
     FNMATCHES = 280,
     MXMATCHES = 281,
     MXFNMATCHES = 282,
     WHEN = 283,
     RATE = 284,
     NEXT = 285,
     SET = 286,
     CATCH = 287,
     KW_ECHO = 288,
     RETURNS = 289,
     RETURN = 290,
     FUNC = 291,
     SWITCH = 292,
     CASE = 293,
     DEFAULT = 294,
     STRING = 295,
     CODE = 296,
     XCODE = 297,
     SYMBOL = 298,
     VARIABLE = 299,
     IDENTIFIER = 300,
     ARG = 301,
     NUMBER = 302,
     BACKREF = 303,
     BUILTIN = 304,
     OR = 305,
     AND = 306,
     EQ = 307,
     NE = 308,
     LT = 309,
     LE = 310,
     GT = 311,
     GE = 312,
     NOT = 313,
     FUNCTION = 314,
     UMINUS = 315
   };
#endif
/* Tokens.  */
#define ACT_ACCEPT 258
#define ACT_REJECT 259
#define ACT_TEMPFAIL 260
#define ACT_CONTINUE 261
#define ACT_DISCARD 262
#define ADD 263
#define REPLACE 264
#define DELETE 265
#define PROG 266
#define IF 267
#define FI 268
#define ELSE 269
#define ELIF 270
#define ON 271
#define HOST 272
#define FOR 273
#define FROM 274
#define AS 275
#define DO 276
#define DONE 277
#define POLL 278
#define MATCHES 279
#define FNMATCHES 280
#define MXMATCHES 281
#define MXFNMATCHES 282
#define WHEN 283
#define RATE 284
#define NEXT 285
#define SET 286
#define CATCH 287
#define KW_ECHO 288
#define RETURNS 289
#define RETURN 290
#define FUNC 291
#define SWITCH 292
#define CASE 293
#define DEFAULT 294
#define STRING 295
#define CODE 296
#define XCODE 297
#define SYMBOL 298
#define VARIABLE 299
#define IDENTIFIER 300
#define ARG 301
#define NUMBER 302
#define BACKREF 303
#define BUILTIN 304
#define OR 305
#define AND 306
#define EQ 307
#define NE 308
#define LT 309
#define LE 310
#define GT 311
#define GE 312
#define NOT 313
#define FUNCTION 314
#define UMINUS 315




/* Copy the first part of user declarations.  */
#line 1 "gram.y"

/* This file is part of mailfrom filter.
   Copyright (C) 2005, 2006 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <fnmatch.h>
#include <netdb.h>
#include "mailfrom.h"

NODE *alloc_node(enum node_type type, const struct locus *locus);
int string_to_stat(char *, mf_status *);
void set_poll_arg(struct poll_data *poll, int kw, NODE *expr);
static int time_multiplier(const char *, unsigned *, unsigned *);
static int codegen(prog_counter_t *pc, NODE *node);
NODE *reverse(NODE *in);
 
static NODE *root_node[smtp_state_count];
prog_counter_t entry_point[smtp_state_count];
 
int regex_flags;        /* Should default to REG_NOSUB ? */
unsigned error_count;   /* Number of detected errors */
size_t variable_count = 1; /* Offset of the next-to-be-defined variable
			      in the data segment */
static enum smtp_state state_tag; /* State tag of the currently processed
				     PROG */

static struct function *func;   /* The currently compiled function */
static prog_counter_t jump_pc;  /* Pointer to the chain of jmp instructions */

/* State handlers and their positional parameters */ 
struct state_parms {
	int cnt;                  /* Number or positional parameters */
	instr_rettype types[2];   /* Their data types */
} state_parms[] = {
	{ 0,  }, /* smtp_state_none */
	{ 0,  }, /* smtp_state_connect */
	{ 1, { rettype_string } },  /* smtp_state_helo */
	{ 1, { rettype_string } },  /* smtp_state_envfrom */
	{ 1, { rettype_string } },  /* smtp_state_envrcpt */
	{ 2, { rettype_string, rettype_string } }, /* smtp_state_header */
	{ 0,  }, /* smtp_state_eoh */
	{ 2, { rettype_string, rettype_number } }, /* smtp_state_body */
	{ 0, }, /* smtp_state_eom */
};

struct parmtype {
	struct parmtype *next;
	instr_rettype type;
};

#define	synt_none        0
#define	synt_handler     1
#define	synt_catch       2
#define	synt_function    3

static int stie_in;
static int allow_unquoted_strings;
 
static int
parmcount_none()
{
	return 0;
}

static instr_rettype
parmtype_none(int n)
{
	return rettype_unspecified;
}
 
static int
parmcount_handler()
{
	return state_parms[state_tag].cnt;
}

static instr_rettype
parmtype_handler(int n)
{
	return state_parms[state_tag].types[n-1];
}

static int
parmcount_catch()
{
	return 1;
}

static instr_rettype
parmtype_catch(int n)
{
	return rettype_number;
}

static int
parmcount_function()
{
	return func->parmcount;
}

static instr_rettype
parmtype_function(int n)
{
	return func->parmtype[n-1];
}

struct parminfo {
	int (*parmcount)(void);
	instr_rettype (*parmtype)(int n);
} parminfo[] = {
	{ parmcount_none, parmtype_none },
	{ parmcount_handler, parmtype_handler },
	{ parmcount_catch, parmtype_catch },
	{ parmcount_function, parmtype_function }
};

#define PARMCOUNT() parminfo[stie_in].parmcount()
#define PARMTYPE(n) parminfo[stie_in].parmtype(n)

instr_rettype
string_to_type(char *s)
{
	if (strcmp(s, "n") == 0)
		return rettype_number;
	else if (strcmp(s, "s") == 0)
		return rettype_string;
	else
		return rettype_unspecified;
}

const char *
type_to_string(instr_rettype t)
{
	switch (t) {
	case rettype_number:
		return "n";
	case rettype_string:
		return "s";
	default:
		return "?";
	}
}

static int
check_builtin(const struct builtin *bp)
{
	if (bp->statemask && !(EXMASK(state_tag) & bp->statemask)) {
		parse_error("Built-in function `%s' cannot be used in "
			    "prog `%s'",
			    bp->name,
			    state_to_string(state_tag));
		return 1;
	}
	if (bp->capture)
		capture_on();
	return 0;
}

static void jump_fixup(prog_counter_t pos, prog_counter_t endpos);
static NODE *create_on_node(NODE *sel, struct case_stmt *cases);
static void register_macro(enum smtp_state tag, char *macro);



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 185 "gram.y"
{
	char *string;
	struct {
		NODE *head;
 		NODE *tail;
	} stmtlist;
	NODE *node;
	struct return_node ret;
	struct poll_data poll;
	struct locus locus;
	struct pollarg {
		int kw;
		NODE *expr;
	} pollarg;
	struct {
		NODE *head;
		NODE *tail;
		size_t count;
	} arglist;
	long number;
	const struct builtin *builtin;
	struct variable *var;
	enum smtp_state state;
	struct {
		struct locus locus;
		int qualifier;
	} matchtype;
	instr_rettype type;
	struct typelist {
		struct parmtype *head, *tail;
		int count;
	} typelist;
	int tie_in;
	struct function *function;
	struct {
		struct valist *head, *tail;
	} valist_list;
	struct valist *valist;
	struct {
		struct case_stmt *head, *tail;
	} case_list ;
	struct case_stmt *case_stmt;
}
/* Line 193 of yacc.c.  */
#line 442 "gram.c"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 455 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  12
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   860

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  69
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  47
/* YYNRULES -- Number of rules.  */
#define YYNRULES  127
/* YYNRULES -- Number of states.  */
#define YYNSTATES  222

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   315

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      65,    66,    62,    60,    67,    61,     2,    63,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    68,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    64
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,    10,    16,    22,    26,    30,
      36,    37,    39,    41,    45,    46,    49,    51,    53,    56,
      58,    60,    62,    64,    66,    70,    73,    76,    79,    81,
      83,    85,    89,    93,    96,    99,   100,   102,   104,   107,
     111,   114,   116,   118,   120,   126,   127,   132,   135,   141,
     143,   146,   151,   155,   157,   161,   163,   165,   167,   171,
     175,   179,   183,   187,   191,   195,   199,   203,   207,   210,
     214,   217,   219,   221,   223,   225,   227,   229,   231,   234,
     238,   242,   246,   250,   253,   257,   259,   261,   263,   265,
     267,   269,   271,   276,   280,   283,   288,   293,   297,   300,
     302,   304,   306,   310,   312,   313,   320,   322,   324,   326,
     329,   335,   341,   343,   345,   348,   352,   355,   357,   360,
     363,   366,   369,   372,   374,   377,   378,   379
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      70,     0,    -1,    71,    -1,    72,    -1,    71,    72,    -1,
      11,    77,    21,    78,    22,    -1,    36,    73,    21,    78,
      22,    -1,    31,    45,    99,    -1,    31,    45,    95,    -1,
      45,    65,    74,    66,    76,    -1,    -1,    75,    -1,    45,
      -1,    75,    67,    45,    -1,    -1,    34,    45,    -1,    45,
      -1,    79,    -1,    78,    79,    -1,    84,    -1,    81,    -1,
      80,    -1,   102,    -1,   105,    -1,    31,    45,    96,    -1,
       3,    82,    -1,     4,    82,    -1,     5,    82,    -1,     6,
      -1,     7,    -1,    30,    -1,     8,    99,    96,    -1,     9,
      99,    96,    -1,    10,    99,    -1,    33,    96,    -1,    -1,
      83,    -1,    41,    -1,    41,    42,    -1,    41,    42,    96,
      -1,    41,    96,    -1,    85,    -1,    87,    -1,   106,    -1,
      12,    92,    78,    86,    13,    -1,    -1,    15,    92,    78,
      86,    -1,    14,    78,    -1,    37,    96,    21,    88,    22,
      -1,    89,    -1,    88,    89,    -1,    38,    90,    68,    78,
      -1,    39,    68,    78,    -1,    91,    -1,    90,    50,    91,
      -1,    99,    -1,    95,    -1,    96,    -1,    96,    52,    96,
      -1,    96,    53,    96,    -1,    96,    54,    96,    -1,    96,
      55,    96,    -1,    96,    56,    96,    -1,    96,    57,    96,
      -1,    96,    93,    96,    -1,    96,    94,    96,    -1,    92,
      50,    92,    -1,    92,    51,    92,    -1,    58,    92,    -1,
      65,    92,    66,    -1,    29,     1,    -1,    24,    -1,    26,
      -1,    25,    -1,    27,    -1,    47,    -1,    41,    -1,    97,
      -1,    96,    97,    -1,    96,    60,    96,    -1,    96,    61,
      96,    -1,    96,    62,    96,    -1,    96,    63,    96,    -1,
      61,    96,    -1,    65,    96,    66,    -1,    99,    -1,    43,
      -1,    95,    -1,    48,    -1,   101,    -1,    46,    -1,    98,
      -1,    49,    65,   100,    66,    -1,    49,    65,    66,    -1,
      49,    96,    -1,    29,    65,   100,    66,    -1,    59,    65,
     100,    66,    -1,    59,    65,    66,    -1,    59,    96,    -1,
      40,    -1,    45,    -1,    96,    -1,   100,    67,    96,    -1,
      44,    -1,    -1,    32,   104,    21,   103,    78,    22,    -1,
      62,    -1,    90,    -1,    35,    -1,    35,    96,    -1,   107,
     109,   108,   112,    22,    -1,   107,    98,   108,   112,    22,
      -1,    16,    -1,    21,    -1,    23,    96,    -1,    23,    96,
     110,    -1,    23,   110,    -1,   111,    -1,   110,   111,    -1,
      18,    96,    -1,    17,    96,    -1,    20,    96,    -1,    19,
      96,    -1,   113,    -1,   112,   113,    -1,    -1,    -1,    28,
     114,    90,    68,   115,    78,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   276,   276,   279,   280,   283,   292,   321,   329,   339,
     362,   365,   368,   380,   396,   399,   408,   420,   425,   433,
     434,   435,   436,   437,   440,   452,   460,   470,   480,   486,
     492,   496,   503,   510,   516,   524,   527,   530,   536,   542,
     548,   556,   557,   558,   561,   571,   574,   581,   587,   628,
     632,   639,   647,   657,   661,   669,   676,   685,   686,   693,
     700,   707,   714,   721,   728,   736,   744,   751,   758,   764,
     768,   775,   780,   787,   792,   799,   800,   812,   813,   819,
     826,   833,   840,   847,   853,   859,   864,   870,   875,   880,
     885,   894,   897,   915,   929,   947,   967,   983,   995,  1013,
    1014,  1022,  1028,  1037,  1047,  1046,  1075,  1093,  1096,  1101,
    1112,  1157,  1163,  1169,  1175,  1184,  1193,  1199,  1204,  1211,
    1216,  1221,  1226,  1234,  1238,  1246,  1247,  1246
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ACT_ACCEPT", "ACT_REJECT",
  "ACT_TEMPFAIL", "ACT_CONTINUE", "ACT_DISCARD", "ADD", "REPLACE",
  "DELETE", "PROG", "IF", "FI", "ELSE", "ELIF", "ON", "HOST", "FOR",
  "FROM", "AS", "DO", "DONE", "POLL", "MATCHES", "FNMATCHES", "MXMATCHES",
  "MXFNMATCHES", "WHEN", "RATE", "NEXT", "SET", "CATCH", "KW_ECHO",
  "RETURNS", "RETURN", "FUNC", "SWITCH", "CASE", "DEFAULT", "STRING",
  "CODE", "XCODE", "SYMBOL", "VARIABLE", "IDENTIFIER", "ARG", "NUMBER",
  "BACKREF", "BUILTIN", "OR", "AND", "EQ", "NE", "LT", "LE", "GT", "GE",
  "NOT", "FUNCTION", "'+'", "'-'", "'*'", "'/'", "UMINUS", "'('", "')'",
  "','", "':'", "$accept", "input", "decllist", "decl", "fundecl",
  "typedecl", "typelist", "retdecl", "state_ident", "stmtlist", "stmt",
  "asgn", "action", "maybe_triplet", "triplet", "condition", "if_cond",
  "else_cond", "case_cond", "cond_branches", "cond_branch", "valist",
  "value", "cond", "matches", "fnmatches", "number", "expr", "atom",
  "funcall", "string", "arglist", "variable", "catch", "@1", "catchlist",
  "return", "on_cond", "on", "do", "pollstmt", "pollarglist", "pollarg",
  "branches", "branch", "@2", "@3", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
      43,    45,    42,    47,   315,    40,    41,    44,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    69,    70,    71,    71,    72,    72,    72,    72,    73,
      74,    74,    75,    75,    76,    76,    77,    78,    78,    79,
      79,    79,    79,    79,    80,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    82,    82,    83,    83,    83,
      83,    84,    84,    84,    85,    86,    86,    86,    87,    88,
      88,    89,    89,    90,    90,    91,    91,    92,    92,    92,
      92,    92,    92,    92,    92,    92,    92,    92,    92,    92,
      92,    93,    93,    94,    94,    95,    95,    96,    96,    96,
      96,    96,    96,    96,    96,    97,    97,    97,    97,    97,
      97,    97,    98,    98,    98,    98,    98,    98,    98,    99,
      99,   100,   100,   101,   103,   102,   104,   104,   105,   105,
     106,   106,   107,   108,   109,   109,   109,   110,   110,   111,
     111,   111,   111,   112,   112,   114,   115,   113
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     2,     5,     5,     3,     3,     5,
       0,     1,     1,     3,     0,     2,     1,     1,     2,     1,
       1,     1,     1,     1,     3,     2,     2,     2,     1,     1,
       1,     3,     3,     2,     2,     0,     1,     1,     2,     3,
       2,     1,     1,     1,     5,     0,     4,     2,     5,     1,
       2,     4,     3,     1,     3,     1,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     3,
       2,     1,     1,     1,     1,     1,     1,     1,     2,     3,
       3,     3,     3,     2,     3,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     2,     4,     4,     3,     2,     1,
       1,     1,     3,     1,     0,     6,     1,     1,     1,     2,
       5,     5,     1,     1,     2,     3,     2,     1,     2,     2,
       2,     2,     2,     1,     2,     0,     0,     6
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     2,     3,    16,     0,     0,
       0,     0,     1,     4,     0,    99,    76,   100,    75,     8,
       7,    10,     0,    35,    35,    35,    28,    29,     0,     0,
       0,     0,   112,    30,     0,     0,     0,   108,     0,     0,
      17,    21,    20,    19,    41,    42,    22,    23,    43,     0,
      12,     0,    11,     0,    37,    25,    36,    26,    27,     0,
       0,    33,     0,    86,   103,    90,    88,     0,     0,     0,
       0,     0,     0,    87,    57,    77,    91,    85,    89,     0,
     106,   107,    53,    56,    55,     0,     0,     0,    34,   109,
       0,     5,    18,     0,     0,     0,    14,     0,     6,    38,
      40,    31,    32,    70,     0,     0,    94,    68,     0,    98,
      83,     0,    57,     0,     0,    45,    71,    73,    72,    74,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,    24,     0,   104,     0,     0,     0,     0,
       0,     0,   114,   116,   117,   113,     0,     0,     0,     9,
      13,    39,   101,     0,    93,   101,     0,    97,     0,    69,
      84,    66,    67,     0,     0,     0,    58,    59,    60,    61,
      62,    63,    79,    80,    81,    82,    64,    65,    54,     0,
       0,     0,     0,    49,   120,   119,   122,   121,   115,   118,
     125,     0,   123,     0,    15,    95,     0,    92,    96,    47,
       0,    44,     0,     0,     0,    48,    50,     0,   111,   124,
     110,   102,    45,   105,     0,    52,     0,    46,    51,   126,
       0,   127
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     4,     5,     6,    11,    51,    52,   149,     8,    39,
      40,    41,    42,    55,    56,    43,    44,   165,    45,   182,
     183,    81,    82,    72,   130,   131,    73,    74,    75,    76,
      77,   153,    78,    46,   179,    85,    47,    48,    49,   146,
      95,   143,   144,   191,   192,   207,   220
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -176
static const yytype_int16 yypact[] =
{
      12,   -19,    13,    31,    42,    12,  -176,  -176,    68,    32,
      39,    91,  -176,  -176,   734,  -176,  -176,  -176,  -176,  -176,
    -176,    69,   734,    72,    72,    72,  -176,  -176,     7,     7,
       7,   451,  -176,  -176,    78,    19,   500,   500,   500,   629,
    -176,  -176,  -176,  -176,  -176,  -176,  -176,  -176,  -176,   -13,
    -176,    59,    62,   664,   477,  -176,  -176,  -176,  -176,   500,
     500,  -176,     2,  -176,  -176,  -176,  -176,   523,   451,   546,
     500,   451,   112,  -176,   344,  -176,  -176,  -176,  -176,   500,
    -176,    80,  -176,  -176,  -176,   110,    67,   500,   732,   732,
     318,  -176,  -176,   177,   113,   113,    99,    90,  -176,   500,
     732,   732,   732,  -176,   500,   397,   801,  -176,   424,   732,
     801,    20,   289,   451,   451,   594,  -176,  -176,  -176,  -176,
     500,   500,   500,   500,   500,   500,   500,   500,   500,   500,
     500,   500,  -176,   732,    32,  -176,   373,   -24,   500,   500,
     500,   500,   262,    65,  -176,  -176,   108,   108,    92,  -176,
    -176,   732,   732,    21,  -176,   373,    36,  -176,    40,  -176,
    -176,    87,  -176,   734,   451,   126,   732,   732,   732,   732,
     732,   732,   756,   756,   780,   780,   732,   732,  -176,   734,
      32,    82,    23,  -176,   732,   732,   732,   732,    65,  -176,
    -176,    -3,  -176,    16,  -176,  -176,   500,  -176,  -176,   734,
     112,  -176,   699,   -37,   734,  -176,  -176,    32,  -176,  -176,
    -176,   732,   594,  -176,   734,   734,   -33,  -176,   734,  -176,
     734,   734
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -176,  -176,  -176,   135,  -176,  -176,  -176,  -176,  -176,   -22,
     -35,  -176,  -176,     9,  -176,  -176,  -176,   -66,  -176,  -176,
     -34,  -175,    17,   -59,  -176,  -176,    -7,   -30,   101,   103,
      -8,   -40,  -176,  -176,  -176,  -176,  -176,  -176,  -176,    58,
    -176,    14,  -132,     8,  -140,  -176,  -176
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      53,    20,    19,   103,    92,   203,    88,    89,    90,   107,
      93,   189,   111,   134,   180,   181,    86,   134,    92,   208,
      59,    60,    61,     1,   100,   190,     7,    84,    83,   101,
     102,   214,   216,    57,    58,   219,    67,   106,   210,   109,
     110,   112,    12,     2,   190,   205,    69,    15,     3,   133,
     115,   209,    17,   209,   161,   162,   189,   136,     9,    15,
      16,   180,   181,   142,    17,   156,    18,   104,   158,   151,
     113,   114,    15,    16,   152,   155,    10,    17,   155,    18,
      92,    80,   138,   139,   140,   141,   159,   195,   196,    14,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   197,   196,    21,   200,   198,   196,   184,   185,
     186,   187,    22,    54,    50,    23,    24,    25,    26,    27,
      28,    29,    30,    79,    31,    96,    84,    83,    32,    97,
     134,   135,   104,   148,   145,   150,   190,   194,   114,   201,
      13,   199,    33,    34,    35,    36,   217,    37,   206,    38,
     204,   178,    94,   147,     0,   193,   188,   202,     0,     0,
       0,     0,   113,   114,    92,     0,   211,    92,     0,     0,
       0,     0,    84,    83,     0,   132,     0,    92,   212,     0,
      92,     0,   215,    92,     0,     0,    92,     0,     0,   132,
     132,   132,   218,     0,   138,   139,   140,   141,   221,    84,
      83,   132,   132,   132,     0,     0,    86,   132,     0,     0,
     132,   132,     0,   132,     0,     0,     0,    15,    16,     0,
      63,    64,    17,    65,    18,    66,    67,     0,     0,     0,
       0,     0,     0,     0,   132,     0,    69,   132,    70,     0,
       0,     0,    87,   132,     0,     0,     0,     0,     0,     0,
       0,     0,   132,   132,     0,     0,   132,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   138,
     139,   140,   141,     0,     0,   132,   132,   132,   132,     0,
       0,    86,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    15,    16,     0,    63,    64,    17,    65,    18,
      66,    67,   132,   116,   117,   118,   119,     0,    86,     0,
       0,    69,   126,   127,   128,   129,     0,     0,     0,    15,
      16,     0,    63,    64,    17,    65,    18,    66,    67,   137,
       0,   120,   121,   122,   123,   124,   125,    86,    69,   126,
     127,   128,   129,     0,     0,   160,     0,     0,    15,    16,
       0,    63,    64,    17,    65,    18,    66,    67,   116,   117,
     118,   119,     0,    86,     0,     0,     0,    69,   126,   127,
     128,   129,     0,     0,    15,    16,     0,    63,    64,    17,
      65,    18,    66,    67,     0,     0,   120,   121,   122,   123,
     124,   125,    86,    69,   126,   127,   128,   129,     0,     0,
       0,     0,     0,    15,    16,     0,    63,    64,    17,    65,
      18,    66,    67,     0,     0,     0,    86,     0,     0,     0,
       0,     0,    69,   126,   127,   128,   129,    15,    16,   160,
      63,    64,    17,    65,    18,    66,    67,     0,     0,     0,
       0,     0,     0,    86,     0,     0,    69,     0,    70,     0,
       0,     0,    87,   154,    15,    16,     0,    63,    64,    17,
      65,    18,    66,    67,     0,     0,     0,     0,     0,     0,
      62,     0,     0,    69,     0,    70,     0,     0,     0,    87,
     157,    15,    16,     0,    63,    64,    17,    65,    18,    66,
      67,     0,     0,     0,     0,     0,    86,     0,     0,    68,
      69,     0,    70,     0,     0,     0,    71,    15,    16,    99,
      63,    64,    17,    65,    18,    66,    67,     0,     0,    86,
       0,     0,     0,     0,     0,     0,    69,     0,    70,     0,
      15,    16,    87,    63,    64,    17,    65,    18,    66,    67,
       0,     0,    86,     0,     0,     0,     0,     0,     0,    69,
       0,    70,     0,    15,    16,    87,    63,    64,    17,    65,
      18,    66,    67,     0,     0,    86,     0,     0,     0,     0,
       0,     0,    69,     0,    70,     0,    15,    16,   105,    63,
      64,    17,    65,    18,    66,    67,     0,    23,    24,    25,
      26,    27,    28,    29,    30,    69,    31,    70,   163,   164,
      32,   108,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    33,    34,    35,    36,     0,    37,
       0,    38,    23,    24,    25,    26,    27,    28,    29,    30,
       0,    31,     0,     0,     0,    32,     0,     0,     0,     0,
       0,    91,     0,     0,     0,     0,     0,     0,     0,    33,
      34,    35,    36,     0,    37,     0,    38,    23,    24,    25,
      26,    27,    28,    29,    30,     0,    31,     0,     0,     0,
      32,     0,     0,     0,     0,     0,    98,     0,     0,     0,
       0,     0,     0,     0,    33,    34,    35,    36,     0,    37,
       0,    38,    23,    24,    25,    26,    27,    28,    29,    30,
       0,    31,     0,     0,     0,    32,     0,     0,     0,     0,
       0,   213,     0,     0,     0,     0,     0,     0,     0,    33,
      34,    35,    36,     0,    37,     0,    38,    23,    24,    25,
      26,    27,    28,    29,    30,     0,    31,     0,     0,     0,
      32,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    86,     0,     0,    33,    34,    35,    36,     0,    37,
       0,    38,    15,    16,     0,    63,    64,    17,    65,    18,
      66,    67,     0,     0,     0,    86,     0,     0,     0,     0,
       0,    69,   126,   127,   128,   129,    15,    16,     0,    63,
      64,    17,    65,    18,    66,    67,     0,     0,     0,    86,
       0,     0,     0,     0,     0,    69,     0,     0,   128,   129,
      15,    16,     0,    63,    64,    17,    65,    18,    66,    67,
      86,     0,     0,     0,     0,     0,     0,     0,     0,    69,
       0,    15,    16,     0,    63,    64,    17,    65,    18,    66,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      69
};

static const yytype_int16 yycheck[] =
{
      22,     9,     9,     1,    39,   180,    36,    37,    38,    68,
      23,   143,    71,    50,    38,    39,    29,    50,    53,    22,
      28,    29,    30,    11,    54,    28,    45,    35,    35,    59,
      60,    68,   207,    24,    25,    68,    49,    67,    22,    69,
      70,    71,     0,    31,    28,    22,    59,    40,    36,    79,
      72,   191,    45,   193,   113,   114,   188,    87,    45,    40,
      41,    38,    39,    93,    45,   105,    47,    65,   108,    99,
      50,    51,    40,    41,   104,   105,    45,    45,   108,    47,
     115,    62,    17,    18,    19,    20,    66,    66,    67,    21,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,    66,    67,    65,   164,    66,    67,   138,   139,
     140,   141,    21,    41,    45,     3,     4,     5,     6,     7,
       8,     9,    10,    45,    12,    66,   134,   134,    16,    67,
      50,    21,    65,    34,    21,    45,    28,    45,    51,    13,
       5,   163,    30,    31,    32,    33,   212,    35,   182,    37,
      68,   134,    49,    95,    -1,   147,   142,   179,    -1,    -1,
      -1,    -1,    50,    51,   199,    -1,   196,   202,    -1,    -1,
      -1,    -1,   180,   180,    -1,    74,    -1,   212,   200,    -1,
     215,    -1,   204,   218,    -1,    -1,   221,    -1,    -1,    88,
      89,    90,   214,    -1,    17,    18,    19,    20,   220,   207,
     207,   100,   101,   102,    -1,    -1,    29,   106,    -1,    -1,
     109,   110,    -1,   112,    -1,    -1,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,    59,   136,    61,    -1,
      -1,    -1,    65,   142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   151,   152,    -1,    -1,   155,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,    17,
      18,    19,    20,    -1,    -1,   184,   185,   186,   187,    -1,
      -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,   211,    24,    25,    26,    27,    -1,    29,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    -1,    -1,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    21,
      -1,    52,    53,    54,    55,    56,    57,    29,    59,    60,
      61,    62,    63,    -1,    -1,    66,    -1,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    24,    25,
      26,    27,    -1,    29,    -1,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    -1,    -1,    52,    53,    54,    55,
      56,    57,    29,    59,    60,    61,    62,    63,    -1,    -1,
      -1,    -1,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    -1,    -1,    -1,    29,    -1,    -1,    -1,
      -1,    -1,    59,    60,    61,    62,    63,    40,    41,    66,
      43,    44,    45,    46,    47,    48,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    29,    -1,    -1,    59,    -1,    61,    -1,
      -1,    -1,    65,    66,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      29,    -1,    -1,    59,    -1,    61,    -1,    -1,    -1,    65,
      66,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    -1,    -1,    -1,    -1,    -1,    29,    -1,    -1,    58,
      59,    -1,    61,    -1,    -1,    -1,    65,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    -1,    -1,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    59,    -1,    61,    -1,
      40,    41,    65,    43,    44,    45,    46,    47,    48,    49,
      -1,    -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,    59,
      -1,    61,    -1,    40,    41,    65,    43,    44,    45,    46,
      47,    48,    49,    -1,    -1,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    59,    -1,    61,    -1,    40,    41,    65,    43,
      44,    45,    46,    47,    48,    49,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    59,    12,    61,    14,    15,
      16,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    -1,    35,
      -1,    37,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    -1,    -1,    -1,    16,    -1,    -1,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    33,    -1,    35,    -1,    37,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    -1,    -1,    -1,
      16,    -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    -1,    35,
      -1,    37,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    -1,    -1,    -1,    16,    -1,    -1,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    33,    -1,    35,    -1,    37,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    -1,    -1,    -1,
      16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    29,    -1,    -1,    30,    31,    32,    33,    -1,    35,
      -1,    37,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    -1,    -1,    -1,    29,    -1,    -1,    -1,    -1,
      -1,    59,    60,    61,    62,    63,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    -1,    -1,    -1,    29,
      -1,    -1,    -1,    -1,    -1,    59,    -1,    -1,    62,    63,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    59,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      59
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    11,    31,    36,    70,    71,    72,    45,    77,    45,
      45,    73,     0,    72,    21,    40,    41,    45,    47,    95,
      99,    65,    21,     3,     4,     5,     6,     7,     8,     9,
      10,    12,    16,    30,    31,    32,    33,    35,    37,    78,
      79,    80,    81,    84,    85,    87,   102,   105,   106,   107,
      45,    74,    75,    78,    41,    82,    83,    82,    82,    99,
      99,    99,    29,    43,    44,    46,    48,    49,    58,    59,
      61,    65,    92,    95,    96,    97,    98,    99,   101,    45,
      62,    90,    91,    95,    99,   104,    29,    65,    96,    96,
      96,    22,    79,    23,    98,   109,    66,    67,    22,    42,
      96,    96,    96,     1,    65,    65,    96,    92,    65,    96,
      96,    92,    96,    50,    51,    78,    24,    25,    26,    27,
      52,    53,    54,    55,    56,    57,    60,    61,    62,    63,
      93,    94,    97,    96,    50,    21,    96,    21,    17,    18,
      19,    20,    96,   110,   111,    21,   108,   108,    34,    76,
      45,    96,    96,   100,    66,    96,   100,    66,   100,    66,
      66,    92,    92,    14,    15,    86,    96,    96,    96,    96,
      96,    96,    96,    96,    96,    96,    96,    96,    91,   103,
      38,    39,    88,    89,    96,    96,    96,    96,   110,   111,
      28,   112,   113,   112,    45,    66,    67,    66,    66,    78,
      92,    13,    78,    90,    68,    22,    89,   114,    22,   113,
      22,    96,    78,    22,    68,    78,    90,    86,    78,    68,
     115,    78
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:
#line 284 "gram.y"
    {
		     root_node[(yyvsp[(2) - (5)].state)] = (yyvsp[(4) - (5)].stmtlist).head;
		     if (codegen(&entry_point[(yyvsp[(2) - (5)].state)], (yyvsp[(4) - (5)].stmtlist).head))
			     error_count++;
		     else
			     milter_enable_state((yyvsp[(2) - (5)].state));
		     stie_in = synt_none;
	     }
    break;

  case 6:
#line 293 "gram.y"
    {
		     prog_counter_t pc;

		     func->node = (yyvsp[(4) - (5)].stmtlist).head;
		     /* Assign the entry point early to properly
			handle recursive functions */
		     func->entry = code_get_counter();

		     /* Entry code */
		     if (func->exmask) {
			     code_instr(instr_saveex);
			     code_immediate((void*)func->exmask);
		     }

		     if (codegen(&pc, (yyvsp[(4) - (5)].stmtlist).head))
			     error_count++;
		     else {
			     jump_fixup(jump_pc, code_get_counter());

			     /* Exit code */
			     if (func->exmask) 
				     code_instr(instr_restex);
			     code_instr(instr_return);
		     }
		     
		     stie_in = synt_none;
		     func = NULL;
	     }
    break;

  case 7:
#line 322 "gram.y"
    {
		     struct variable *var = variable_install((yyvsp[(2) - (3)].string));
		     if (var->off == 0)
			     var->off = variable_count++;
		     var->type = rettype_string;
		     declare_string_variable(var, (yyvsp[(3) - (3)].string));
	     }
    break;

  case 8:
#line 330 "gram.y"
    {
		     struct variable *var = variable_install((yyvsp[(2) - (3)].string));
		     if (var->off == 0)
			     var->off = variable_count++;
		     var->type = rettype_number;
		     declare_numeric_variable(var, (yyvsp[(3) - (3)].number));
	     }
    break;

  case 9:
#line 340 "gram.y"
    {
		     instr_rettype *ptypes = NULL;
		     
		     if ((yyvsp[(3) - (5)].typelist).count) {
			     int i;
			     struct parmtype *p;
			     
			     ptypes = emalloc((yyvsp[(3) - (5)].typelist).count*sizeof *ptypes);
			     for (i = 0, p = (yyvsp[(3) - (5)].typelist).head; p; i++) {
				     struct parmtype *next = p->next;
				     ptypes[i] = p->type;
				     free(p);
				     p = next;
			     }
		     }

		     (yyval.function) = func = function_install((yyvsp[(1) - (5)].string), (yyvsp[(3) - (5)].typelist).count, ptypes, (yyvsp[(5) - (5)].type),
						  get_locus());
		     stie_in = synt_function;
	     }
    break;

  case 10:
#line 362 "gram.y"
    {
		     (yyval.typelist).count = 0;
	     }
    break;

  case 12:
#line 369 "gram.y"
    {
		     (yyval.typelist).head = emalloc(sizeof *(yyval.typelist).head);
		     (yyval.typelist).head->next = NULL;
		     if (((yyval.typelist).head->type = string_to_type((yyvsp[(1) - (1)].string)))
			 == rettype_unspecified) {
			     parse_error("unknown type specification: %s", (yyvsp[(1) - (1)].string));
			     error_count++;
		     }
		     (yyval.typelist).tail = (yyval.typelist).head;
		     (yyval.typelist).count = 1;
	     }
    break;

  case 13:
#line 381 "gram.y"
    {
		     struct parmtype *p = emalloc(sizeof *p);
		     p->next = NULL;
		     if ((p->type = string_to_type((yyvsp[(3) - (3)].string)))
			 == rettype_unspecified) {
			     parse_error("unknown type specification: %s", (yyvsp[(3) - (3)].string));
			     error_count++;
		     }
		     (yyval.typelist).tail->next = p;
		     (yyval.typelist).tail = p;
		     (yyval.typelist).count++;
	     }
    break;

  case 14:
#line 396 "gram.y"
    {
		     (yyval.type) = rettype_unspecified;
	     }
    break;

  case 15:
#line 400 "gram.y"
    {
		     if (((yyval.type) = string_to_type((yyvsp[(2) - (2)].string))) == rettype_unspecified) {
			     parse_error("unknown type specification: %s", (yyvsp[(2) - (2)].string));
			     error_count++;
		     }
	     }
    break;

  case 16:
#line 409 "gram.y"
    {
		     (yyval.state) = string_to_state((yyvsp[(1) - (1)].string));
		     if ((yyval.state) == smtp_state_none) {
			     parse_error("Unknown smtp state tag: %s", (yyvsp[(1) - (1)].string));
			     error_count++;
		     }
		     state_tag = (yyval.state);
		     stie_in = synt_handler;
	     }
    break;

  case 17:
#line 421 "gram.y"
    {
		     (yyvsp[(1) - (1)].node)->next = NULL;
		     (yyval.stmtlist).head = (yyval.stmtlist).tail = (yyvsp[(1) - (1)].node);
	     }
    break;

  case 18:
#line 426 "gram.y"
    {
		     (yyvsp[(1) - (2)].stmtlist).tail->next = (yyvsp[(2) - (2)].node);
		     (yyvsp[(1) - (2)].stmtlist).tail = (yyvsp[(2) - (2)].node);
		     (yyval.stmtlist) = (yyvsp[(1) - (2)].stmtlist);
	     }
    break;

  case 24:
#line 441 "gram.y"
    {
		     struct variable *var;
		     (yyval.node) = alloc_node(node_type_asgn, &(yyvsp[(1) - (3)].locus));
		     var = variable_install((yyvsp[(2) - (3)].string));
		     if (var->off == 0)
			     var->off = variable_count++;
		     (yyval.node)->v.asgn.var = var;
		     (yyval.node)->v.asgn.node = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 25:
#line 453 "gram.y"
    {
		     if ((yyvsp[(2) - (2)].ret).code || (yyvsp[(2) - (2)].ret).xcode || (yyvsp[(2) - (2)].ret).message)
			     parse_error("warning: arguments are ignored for accept");
		     (yyval.node) = alloc_node(node_type_result, &(yyvsp[(1) - (2)].locus));
		     (yyval.node)->v.ret = (yyvsp[(2) - (2)].ret);
		     (yyval.node)->v.ret.stat = SMFIS_ACCEPT;
	     }
    break;

  case 26:
#line 461 "gram.y"
    {
		     if  ((yyvsp[(2) - (2)].ret).code && (yyvsp[(2) - (2)].ret).code[0] != '5')
			     parse_error("reject code should be 5xx");
		     if  ((yyvsp[(2) - (2)].ret).xcode && (yyvsp[(2) - (2)].ret).xcode[0] != '5')
			     parse_error("reject extended code should be 5.x.x");
		     (yyval.node) = alloc_node(node_type_result, &(yyvsp[(1) - (2)].locus));
		     (yyval.node)->v.ret = (yyvsp[(2) - (2)].ret);
		     (yyval.node)->v.ret.stat = SMFIS_REJECT;
	     }
    break;

  case 27:
#line 471 "gram.y"
    {
		     if  ((yyvsp[(2) - (2)].ret).code && (yyvsp[(2) - (2)].ret).code[0] != '4')
			     parse_error("tempfail code should be 4xx");
		     if  ((yyvsp[(2) - (2)].ret).xcode && (yyvsp[(2) - (2)].ret).xcode[0] != '4')
			     parse_error("tempfail extended code should be 4.x.x");
		     (yyval.node) = alloc_node(node_type_result, &(yyvsp[(1) - (2)].locus));
		     (yyval.node)->v.ret = (yyvsp[(2) - (2)].ret);
		     (yyval.node)->v.ret.stat = SMFIS_TEMPFAIL;
	     }
    break;

  case 28:
#line 481 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_result, &(yyvsp[(1) - (1)].locus));
		     memset(&(yyval.node)->v.ret, 0, sizeof (yyval.node)->v.ret);
		     (yyval.node)->v.ret.stat = SMFIS_CONTINUE;
	     }
    break;

  case 29:
#line 487 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_result, &(yyvsp[(1) - (1)].locus));
		     memset(&(yyval.node)->v.ret, 0, sizeof (yyval.node)->v.ret);
		     (yyval.node)->v.ret.stat = SMFIS_DISCARD;
	     }
    break;

  case 30:
#line 493 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_next, &(yyvsp[(1) - (1)].locus));
	     }
    break;

  case 31:
#line 497 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_header, &(yyvsp[(1) - (3)].locus));
		     (yyval.node)->v.hdr.opcode = header_add;
		     (yyval.node)->v.hdr.name = (yyvsp[(2) - (3)].string);
		     (yyval.node)->v.hdr.value = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 32:
#line 504 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_header, &(yyvsp[(1) - (3)].locus));
		     (yyval.node)->v.hdr.opcode = header_replace;
		     (yyval.node)->v.hdr.name = (yyvsp[(2) - (3)].string);
		     (yyval.node)->v.hdr.value = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 33:
#line 511 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_header, &(yyvsp[(1) - (2)].locus));
		     (yyval.node)->v.hdr.opcode = header_delete;
		     (yyval.node)->v.hdr.name = (yyvsp[(2) - (2)].string);
	     }
    break;

  case 34:
#line 517 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_echo, &(yyvsp[(1) - (2)].locus));
		     (yyval.node)->v.node = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 35:
#line 524 "gram.y"
    {
		     memset(&(yyval.ret), 0, sizeof (yyval.ret));
	     }
    break;

  case 37:
#line 531 "gram.y"
    {
		     (yyval.ret).code = (yyvsp[(1) - (1)].string);
		     (yyval.ret).xcode = NULL;
		     (yyval.ret).message = NULL;
	     }
    break;

  case 38:
#line 537 "gram.y"
    {
		     (yyval.ret).code = (yyvsp[(1) - (2)].string);
		     (yyval.ret).xcode = (yyvsp[(2) - (2)].string);
		     (yyval.ret).message = NULL;
	     }
    break;

  case 39:
#line 543 "gram.y"
    {
		     (yyval.ret).code = (yyvsp[(1) - (3)].string);
		     (yyval.ret).xcode = (yyvsp[(2) - (3)].string);
		     (yyval.ret).message = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 40:
#line 549 "gram.y"
    {
		     (yyval.ret).code = (yyvsp[(1) - (2)].string);
		     (yyval.ret).xcode = NULL;
		     (yyval.ret).message = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 44:
#line 562 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_if, &(yyvsp[(1) - (5)].locus));
		     (yyval.node)->v.cond.cond = (yyvsp[(2) - (5)].node);
		     (yyval.node)->v.cond.if_true = (yyvsp[(3) - (5)].stmtlist).head;
		     (yyval.node)->v.cond.if_false = (yyvsp[(4) - (5)].node);
	     }
    break;

  case 45:
#line 571 "gram.y"
    {
		     (yyval.node) = NULL;
	     }
    break;

  case 46:
#line 575 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_if, &(yyvsp[(1) - (4)].locus));
		     (yyval.node)->v.cond.cond = (yyvsp[(2) - (4)].node);
		     (yyval.node)->v.cond.if_true = (yyvsp[(3) - (4)].stmtlist).head;
		     (yyval.node)->v.cond.if_false = (yyvsp[(4) - (4)].node);
	     }
    break;

  case 47:
#line 582 "gram.y"
    {
		     (yyval.node) = (yyvsp[(2) - (2)].stmtlist).head;
	     }
    break;

  case 48:
#line 588 "gram.y"
    {
		     struct case_stmt *defcase = NULL, *pcase, *prev;
		     
		     (yyval.node) = alloc_node(node_type_switch, &(yyvsp[(1) - (5)].locus));
		     (yyval.node)->v.switch_stmt.node = (yyvsp[(2) - (5)].node);
		     
		     /* Make sure there is only one default case and
			place it at the beginning of the list */
		     pcase = (yyvsp[(4) - (5)].case_list).head;
		     if (!pcase->valist) {
			     defcase = pcase;
			     (yyvsp[(4) - (5)].case_list).head = (yyvsp[(4) - (5)].case_list).head->next;
		     }
		     prev = pcase;
		     pcase = pcase->next;
		     while (pcase) {
			     if (!pcase->valist) {
				     if (defcase) {
					     parse_error_locus(&pcase->locus,
					       "duplicate default statement");
					     parse_error_locus(&defcase->locus,
					       "previously defined here");
					     YYERROR;
				     }
				     defcase = pcase;
				     prev->next = pcase->next;
			     } else
				     prev = pcase;
			     pcase = pcase->next;
		     }

		     if (defcase) {
			     defcase->next = (yyvsp[(4) - (5)].case_list).head;
			     (yyvsp[(4) - (5)].case_list).head = defcase;
		     }

		     (yyval.node)->v.switch_stmt.cases = (yyvsp[(4) - (5)].case_list).head;
	     }
    break;

  case 49:
#line 629 "gram.y"
    {
		       (yyval.case_list).head = (yyval.case_list).tail = (yyvsp[(1) - (1)].case_stmt);
	       }
    break;

  case 50:
#line 633 "gram.y"
    {
		       (yyval.case_list).tail->next = (yyvsp[(2) - (2)].case_stmt);
		       (yyval.case_list).tail = (yyvsp[(2) - (2)].case_stmt);
	       }
    break;

  case 51:
#line 640 "gram.y"
    {
		     (yyval.case_stmt) = emalloc(sizeof *(yyval.case_stmt));
		     (yyval.case_stmt)->next = NULL;
		     (yyval.case_stmt)->locus = (yyvsp[(1) - (4)].locus);
		     (yyval.case_stmt)->valist = (yyvsp[(2) - (4)].valist_list).head;
		     (yyval.case_stmt)->node = (yyvsp[(4) - (4)].stmtlist).head;
	     }
    break;

  case 52:
#line 648 "gram.y"
    {
		     (yyval.case_stmt) = emalloc(sizeof *(yyval.case_stmt));
		     (yyval.case_stmt)->next = NULL;
		     (yyval.case_stmt)->locus = (yyvsp[(1) - (3)].locus);
		     (yyval.case_stmt)->valist = NULL;
		     (yyval.case_stmt)->node = (yyvsp[(3) - (3)].stmtlist).head;
	     }
    break;

  case 53:
#line 658 "gram.y"
    {
		     (yyval.valist_list).head = (yyval.valist_list).tail = (yyvsp[(1) - (1)].valist);
	     }
    break;

  case 54:
#line 662 "gram.y"
    {
		     (yyvsp[(1) - (3)].valist_list).tail->next = (yyvsp[(3) - (3)].valist);
		     (yyvsp[(1) - (3)].valist_list).tail = (yyvsp[(3) - (3)].valist);
		     (yyval.valist_list) = (yyvsp[(1) - (3)].valist_list);
	     }
    break;

  case 55:
#line 670 "gram.y"
    {
		     (yyval.valist) = emalloc(sizeof *(yyval.valist));
		     (yyval.valist)->next = NULL;
		     (yyval.valist)->value.type = rettype_string;
		     (yyval.valist)->value.v.string = (yyvsp[(1) - (1)].string);
	     }
    break;

  case 56:
#line 677 "gram.y"
    {
		     (yyval.valist) = emalloc(sizeof *(yyval.valist));
		     (yyval.valist)->next = NULL;
		     (yyval.valist)->value.type = rettype_number;
		     (yyval.valist)->value.v.number = (yyvsp[(1) - (1)].number);
	     }
    break;

  case 58:
#line 687 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].locus));
		     (yyval.node)->v.bin.opcode = bin_eq;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 59:
#line 694 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].locus));
		     (yyval.node)->v.bin.opcode = bin_ne;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 60:
#line 701 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].locus));
		     (yyval.node)->v.bin.opcode = bin_lt;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 61:
#line 708 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].locus));
		     (yyval.node)->v.bin.opcode = bin_le;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 62:
#line 715 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].locus));
		     (yyval.node)->v.bin.opcode = bin_gt;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 63:
#line 722 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].locus));
		     (yyval.node)->v.bin.opcode = bin_ge;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 64:
#line 729 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].matchtype).locus);
		     (yyval.node)->v.bin.opcode = bin_match;
		     (yyval.node)->v.bin.qualifier = (yyvsp[(2) - (3)].matchtype).qualifier;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 65:
#line 737 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].matchtype).locus);
		     (yyval.node)->v.bin.opcode = bin_fnmatch;
		     (yyval.node)->v.bin.qualifier = (yyvsp[(2) - (3)].matchtype).qualifier;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 66:
#line 745 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].locus));
		     (yyval.node)->v.bin.opcode = bin_or;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 67:
#line 752 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].locus));
		     (yyval.node)->v.bin.opcode = bin_and;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 68:
#line 759 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_un, &(yyvsp[(1) - (2)].locus));
		     (yyval.node)->v.un.opcode = unary_not;
		     (yyval.node)->v.un.arg = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 69:
#line 765 "gram.y"
    {
		     (yyval.node) = (yyvsp[(2) - (3)].node);
	     }
    break;

  case 70:
#line 769 "gram.y"
    {
		     parse_error("`rate' statement is no longer supported, use function instead;");
		     parse_error("refer to FIXME-xref for the detailed discussion");
	     }
    break;

  case 71:
#line 776 "gram.y"
    {
		     (yyval.matchtype).locus = (yyvsp[(1) - (1)].locus);
		     (yyval.matchtype).qualifier = 0;
	     }
    break;

  case 72:
#line 781 "gram.y"
    {
		     (yyval.matchtype).locus = (yyvsp[(1) - (1)].locus);
		     (yyval.matchtype).qualifier = QUALIFIER_MX;
	     }
    break;

  case 73:
#line 788 "gram.y"
    {
		     (yyval.matchtype).locus = (yyvsp[(1) - (1)].locus);
		     (yyval.matchtype).qualifier = 0;
	     }
    break;

  case 74:
#line 793 "gram.y"
    {
		     (yyval.matchtype).locus = (yyvsp[(1) - (1)].locus);
		     (yyval.matchtype).qualifier = QUALIFIER_MX;
	     }
    break;

  case 76:
#line 801 "gram.y"
    {
		     char *p;
		     (yyval.number) = strtol((yyvsp[(1) - (1)].string), &p, 10);
		     if (*p) {
			     /* should not happen */
			     parse_error("Invalid number (near `%s')", p);
			     YYERROR;
		     }
	     }
    break;

  case 78:
#line 814 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_concat, get_locus());
		     (yyval.node)->v.concat.arg[0] = (yyvsp[(1) - (2)].node);
		     (yyval.node)->v.concat.arg[1] = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 79:
#line 820 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, get_locus());
		     (yyval.node)->v.bin.opcode = bin_add;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 80:
#line 827 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, get_locus());
		     (yyval.node)->v.bin.opcode = bin_sub;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 81:
#line 834 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, get_locus());
		     (yyval.node)->v.bin.opcode = bin_mul;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 82:
#line 841 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, get_locus());
		     (yyval.node)->v.bin.opcode = bin_div;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 83:
#line 848 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_un, get_locus());
		     (yyval.node)->v.un.opcode = unary_minus;
		     (yyval.node)->v.un.arg = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 84:
#line 854 "gram.y"
    {
		     (yyval.node) = (yyvsp[(2) - (3)].node);
	     }
    break;

  case 85:
#line 860 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_string, get_locus());
		     (yyval.node)->v.string = (yyvsp[(1) - (1)].string);
	     }
    break;

  case 86:
#line 865 "gram.y"
    {
		     register_macro(state_tag, (yyvsp[(1) - (1)].string));
		     (yyval.node) = alloc_node(node_type_symbol, get_locus());
		     (yyval.node)->v.string = (yyvsp[(1) - (1)].string);
	     }
    break;

  case 87:
#line 871 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_number, get_locus());
		     (yyval.node)->v.number = (yyvsp[(1) - (1)].number);
	     }
    break;

  case 88:
#line 876 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_backref, get_locus());
		     (yyval.node)->v.number = (yyvsp[(1) - (1)].number);
	     }
    break;

  case 89:
#line 881 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_variable, get_locus());
		     (yyval.node)->v.variable = (yyvsp[(1) - (1)].var);
	     }
    break;

  case 90:
#line 886 "gram.y"
    {
		     if ((yyvsp[(1) - (1)].number) > PARMCOUNT()) { 
			     parse_error("Argument number too high");
			     error_count++;
		     }
		     (yyval.node) = alloc_node(node_type_arg, get_locus());
		     (yyval.node)->v.number = (yyvsp[(1) - (1)].number);
	     }
    break;

  case 92:
#line 898 "gram.y"
    {
		     if (check_builtin((yyvsp[(1) - (4)].builtin)))
			     YYERROR;
		     if ((yyvsp[(3) - (4)].arglist).count < (yyvsp[(1) - (4)].builtin)->parmcount) {
			     parse_error("Too few arguments in call to `%s'",
					 (yyvsp[(1) - (4)].builtin)->name);
			     YYERROR;
		     } else if ((yyvsp[(3) - (4)].arglist).count > (yyvsp[(1) - (4)].builtin)->parmcount) {
			     parse_error("Too many arguments in call to `%s'",
					 (yyvsp[(1) - (4)].builtin)->name);
			     YYERROR;
		     } else {
			     (yyval.node) = alloc_node(node_type_builtin, get_locus());
			     (yyval.node)->v.builtin.builtin = (yyvsp[(1) - (4)].builtin);
			     (yyval.node)->v.builtin.args = (yyvsp[(3) - (4)].arglist).head;
		     }
	     }
    break;

  case 93:
#line 916 "gram.y"
    {
		     if (check_builtin((yyvsp[(1) - (3)].builtin)))
			     YYERROR;
		     if ((yyvsp[(1) - (3)].builtin)->parmcount) {
			     parse_error("Too few arguments in call to `%s'",
					 (yyvsp[(1) - (3)].builtin)->name);
			     YYERROR;
		     } else {
 			     (yyval.node) = alloc_node(node_type_builtin, get_locus());
			     (yyval.node)->v.builtin.builtin = (yyvsp[(1) - (3)].builtin);
			     (yyval.node)->v.builtin.args = NULL;
		     }
	     }
    break;

  case 94:
#line 930 "gram.y"
    {
		     if (check_builtin((yyvsp[(1) - (2)].builtin)))
			     YYERROR;
		     if ((yyvsp[(1) - (2)].builtin)->parmcount > 1) {
			     parse_error("Too few arguments in call to `%s'",
					 (yyvsp[(1) - (2)].builtin)->name);
			     YYERROR;
		     } else if ((yyvsp[(1) - (2)].builtin)->parmcount == 0) {
			     parse_error("Too many arguments in call to `%s'",
					 (yyvsp[(1) - (2)].builtin)->name);
			     YYERROR;
		     } else {
			     (yyval.node) = alloc_node(node_type_builtin, get_locus());
			     (yyval.node)->v.builtin.builtin = (yyvsp[(1) - (2)].builtin);
			     (yyval.node)->v.builtin.args = (yyvsp[(2) - (2)].node);
		     }
	     }
    break;

  case 95:
#line 948 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_builtin, get_locus());
		     (yyval.node)->v.builtin.builtin = builtin_lookup("rate");
		     if (!(yyval.node)->v.builtin.builtin) {
			     parse_error("Function `%s' is not defined",
					 "rate");
			     YYERROR;
		     }
		     if ((yyvsp[(3) - (4)].arglist).count < (yyval.node)->v.builtin.builtin->parmcount) {
			     parse_error("Too few arguments in call to `%s'",
					 "rate");
			     YYERROR;
		     } else if ((yyvsp[(3) - (4)].arglist).count > (yyval.node)->v.builtin.builtin->parmcount) {
			     parse_error("Too many arguments in call to `%s'",
					 "rate");
			     YYERROR;
		     }
		     (yyval.node)->v.builtin.args = (yyvsp[(3) - (4)].arglist).head;
	     }
    break;

  case 96:
#line 968 "gram.y"
    {
		     if ((yyvsp[(3) - (4)].arglist).count < (yyvsp[(1) - (4)].function)->parmcount) {
			     parse_error("Too few arguments in call to `%s'",
					 (yyvsp[(1) - (4)].function)->name);
			     YYERROR;
		     } else if ((yyvsp[(3) - (4)].arglist).count > (yyvsp[(1) - (4)].function)->parmcount) {
			     parse_error("Too many arguments in call to `%s'",
					 (yyvsp[(1) - (4)].function)->name);
			     YYERROR;
		     } else {
			     (yyval.node) = alloc_node(node_type_call, get_locus());
			     (yyval.node)->v.call.func = (yyvsp[(1) - (4)].function);
			     (yyval.node)->v.call.args = reverse((yyvsp[(3) - (4)].arglist).head);
		     }
	     }
    break;

  case 97:
#line 984 "gram.y"
    {
		     if ((yyvsp[(1) - (3)].function)->parmcount) {
			     parse_error("Too few arguments in call to `%s'",
					 (yyvsp[(1) - (3)].function)->name);
			     YYERROR;
		     } else {
 			     (yyval.node) = alloc_node(node_type_call, get_locus());
			     (yyval.node)->v.call.func = (yyvsp[(1) - (3)].function);
			     (yyval.node)->v.call.args = NULL;
		     }
	     }
    break;

  case 98:
#line 996 "gram.y"
    {
		     if ((yyvsp[(1) - (2)].function)->parmcount > 1) {
			     parse_error("Too few arguments in call to `%s'",
					 (yyvsp[(1) - (2)].function)->name);
			     YYERROR;
		     } else if ((yyvsp[(1) - (2)].function)->parmcount == 0) {
			     parse_error("Too many arguments in call to `%s'",
					 (yyvsp[(1) - (2)].function)->name);
			     YYERROR;
		     } else {
			     (yyval.node) = alloc_node(node_type_call, get_locus());
			     (yyval.node)->v.call.func = (yyvsp[(1) - (2)].function);
			     (yyval.node)->v.call.args = (yyvsp[(2) - (2)].node);
		     }
	     }
    break;

  case 100:
#line 1015 "gram.y"
    {
		     if (!allow_unquoted_strings)
			     parse_error("warning: unquoted identifier `%s'",
					 (yyvsp[(1) - (1)].string));
	     }
    break;

  case 101:
#line 1023 "gram.y"
    {
		     (yyvsp[(1) - (1)].node)->next = NULL;
		     (yyval.arglist).head = (yyval.arglist).tail = (yyvsp[(1) - (1)].node);
		     (yyval.arglist).count = 1;
	     }
    break;

  case 102:
#line 1029 "gram.y"
    {
		     (yyvsp[(1) - (3)].arglist).tail->next = (yyvsp[(3) - (3)].node);
		     (yyvsp[(1) - (3)].arglist).tail = (yyvsp[(3) - (3)].node);
		     (yyvsp[(1) - (3)].arglist).count++;
		     (yyval.arglist) = (yyvsp[(1) - (3)].arglist);
	     }
    break;

  case 103:
#line 1038 "gram.y"
    {
		     (yyval.var) = variable_lookup((yyvsp[(1) - (1)].string));
		     if (!(yyval.var)) {
			     parse_error("Variable %s is not defined", (yyvsp[(1) - (1)].string));
			     YYERROR;
		     }
	     }
    break;

  case 104:
#line 1047 "gram.y"
    { (yyval.tie_in) = stie_in; stie_in = synt_catch; }
    break;

  case 105:
#line 1049 "gram.y"
    {
		      int i;
		      struct valist *p;

		      stie_in = (yyvsp[(4) - (6)].tie_in);
		      (yyval.node) = alloc_node(node_type_catch, &(yyvsp[(1) - (6)].locus));
		      for (i = 0, p = (yyvsp[(2) - (6)].valist_list).head; p; p = p->next)
			      i++;
		      (yyval.node)->v.catch.count = i;
		      (yyval.node)->v.catch.exmask = 0;
		      for (i = 0, p = (yyvsp[(2) - (6)].valist_list).head; p; p = p->next, i++) {
			      if (p->value.type != rettype_number) {
				      parse_error_locus(&(yyvsp[(1) - (6)].locus),
							"expected numeric value, but found `%s'",
							p->value.v.string);
				      error_count++;
				      continue;
			      }
			      (yyval.node)->v.catch.exmask |= EXMASK(p->value.v.number);
			      if (stie_in == synt_function)
				      func->exmask |= EXMASK(p->value.v.number);
		      }
		      (yyval.node)->v.catch.node = (yyvsp[(5) - (6)].stmtlist).head;
	      }
    break;

  case 106:
#line 1076 "gram.y"
    {
		      int i;

		      (yyval.valist_list).head = (yyval.valist_list).tail = NULL;
		      for (i = 0; i < mf_status_count; i++) {
			      struct valist *p = emalloc(sizeof *p);
			      p->next = NULL; 
			      p->value.type = rettype_number;
			      p->value.v.number = i;
			      if (!(yyval.valist_list).head)
				      (yyval.valist_list).head = (yyval.valist_list).tail = p;
			      else {
				      (yyval.valist_list).tail->next = p;
				      (yyval.valist_list).tail = p;
			      }
		      }
	      }
    break;

  case 108:
#line 1097 "gram.y"
    {
		      (yyval.node) = alloc_node(node_type_return, &(yyvsp[(1) - (1)].locus));
		      (yyval.node)->v.node = NULL;
	      }
    break;

  case 109:
#line 1102 "gram.y"
    {
		      (yyval.node) = alloc_node(node_type_return, &(yyvsp[(1) - (2)].locus));
		      (yyval.node)->v.node = (yyvsp[(2) - (2)].node);
	      }
    break;

  case 110:
#line 1113 "gram.y"
    {
		     NODE *sel, *np;
		     NODE *head = NULL, *tail;
		     const struct builtin *bi;
		     
		     /* Build argument list */
		     if ((yyvsp[(2) - (5)].poll).client_addr) {
			     head = tail = (yyvsp[(2) - (5)].poll).client_addr;
			     tail = (yyvsp[(2) - (5)].poll).email;
			     tail->next = NULL;
			     head->next = tail;
		     } else
			     head = tail = (yyvsp[(2) - (5)].poll).email;

		     if ((yyvsp[(2) - (5)].poll).ehlo)
			     np = (yyvsp[(2) - (5)].poll).ehlo;
		     else {
			     np = alloc_node(node_type_variable, get_locus());
			     np->v.variable = variable_lookup("ehlo_domain");
		     }
		     tail->next = np;
		     tail = np;

		     if ((yyvsp[(2) - (5)].poll).mailfrom)
			     np = (yyvsp[(2) - (5)].poll).mailfrom;
		     else {
			     np = alloc_node(node_type_variable, get_locus());
			     np->v.variable =
				     variable_lookup("mailfrom_address");
		     }
		     tail->next = np;
		     tail = np;

		     if ((yyvsp[(2) - (5)].poll).client_addr) 
			     bi = builtin_lookup("strictpoll");
		     else
			     bi = builtin_lookup("stdpoll");
		     
		     sel = alloc_node(node_type_builtin, &(yyvsp[(1) - (5)].locus));
		     sel->v.builtin.builtin = bi;
		     sel->v.builtin.args = head;

		     (yyval.node) = create_on_node(sel, (yyvsp[(4) - (5)].case_list).head);
	     }
    break;

  case 111:
#line 1158 "gram.y"
    {
		     (yyval.node) = create_on_node((yyvsp[(2) - (5)].node), (yyvsp[(4) - (5)].case_list).head);
	     }
    break;

  case 112:
#line 1164 "gram.y"
    {
		     onblock(1);
	     }
    break;

  case 113:
#line 1170 "gram.y"
    {
		     onblock(0);
	     }
    break;

  case 114:
#line 1176 "gram.y"
    {
		     struct pollarg arg;
		     
		     arg.kw = FOR;
		     arg.expr = (yyvsp[(2) - (2)].node);
		     memset(&(yyval.poll), 0, sizeof (yyval.poll));
		     set_poll_arg(&(yyval.poll), arg.kw, arg.expr);
	     }
    break;

  case 115:
#line 1185 "gram.y"
    {
		     struct pollarg arg;
		     
		     arg.kw = FOR;
		     arg.expr = (yyvsp[(2) - (3)].node);
		     set_poll_arg(&(yyvsp[(3) - (3)].poll), arg.kw, arg.expr);
		     (yyval.poll) = (yyvsp[(3) - (3)].poll);
	     }
    break;

  case 116:
#line 1194 "gram.y"
    {
		     (yyval.poll) = (yyvsp[(2) - (2)].poll);
	     }
    break;

  case 117:
#line 1200 "gram.y"
    {
		     memset(&(yyval.poll), 0, sizeof (yyval.poll));
		     set_poll_arg(&(yyval.poll), (yyvsp[(1) - (1)].pollarg).kw, (yyvsp[(1) - (1)].pollarg).expr);
	     }
    break;

  case 118:
#line 1205 "gram.y"
    {
		     set_poll_arg(&(yyvsp[(1) - (2)].poll), (yyvsp[(2) - (2)].pollarg).kw, (yyvsp[(2) - (2)].pollarg).expr);
		     (yyval.poll) = (yyvsp[(1) - (2)].poll);
	     }
    break;

  case 119:
#line 1212 "gram.y"
    {
		     (yyval.pollarg).kw = FOR;
		     (yyval.pollarg).expr = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 120:
#line 1217 "gram.y"
    {
		     (yyval.pollarg).kw = HOST;
		     (yyval.pollarg).expr = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 121:
#line 1222 "gram.y"
    {
		     (yyval.pollarg).kw = AS;
		     (yyval.pollarg).expr = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 122:
#line 1227 "gram.y"
    {
		     (yyval.pollarg).kw = FROM;
		     (yyval.pollarg).expr = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 123:
#line 1235 "gram.y"
    {
		     (yyval.case_list).head = (yyval.case_list).tail = (yyvsp[(1) - (1)].case_stmt);
	     }
    break;

  case 124:
#line 1239 "gram.y"
    {
		     (yyvsp[(1) - (2)].case_list).tail->next = (yyvsp[(2) - (2)].case_stmt);
		     (yyvsp[(1) - (2)].case_list).tail = (yyvsp[(2) - (2)].case_stmt);
		     (yyval.case_list) = (yyvsp[(1) - (2)].case_list);
	     }
    break;

  case 125:
#line 1246 "gram.y"
    { allow_unquoted_strings = 1; }
    break;

  case 126:
#line 1247 "gram.y"
    { allow_unquoted_strings = 0; }
    break;

  case 127:
#line 1248 "gram.y"
    {
		     struct valist *p;

		     for (p = (yyvsp[(3) - (6)].valist_list).head; p; p = p->next) {
			     if (p->value.type == rettype_string) {
				     mf_status status;
				     if (string_to_stat(p->value.v.string,
							&status)) {
				        parse_error("Unknown return code: %s",
						    p->value.v.string);
					YYERROR;
				     }
				     p->value.type = rettype_number;
				     p->value.v.number = status;
			     }
		     }
		     
		     (yyval.case_stmt) = emalloc(sizeof *(yyval.case_stmt));
		     (yyval.case_stmt)->next = NULL;
		     (yyval.case_stmt)->locus = (yyvsp[(1) - (6)].locus);
		     (yyval.case_stmt)->valist = (yyvsp[(3) - (6)].valist_list).head;
		     (yyval.case_stmt)->node = (yyvsp[(6) - (6)].stmtlist).head;
	     }
    break;


/* Line 1267 of yacc.c.  */
#line 3206 "gram.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 1273 "gram.y"


int
yyerror(char *s)
{
	parse_error("%s", s);
	error_count++;
}


int
parse_config(char *name, int ydebug, int ldebug)
{
	yydebug = ydebug;
	if (source(name, ldebug))
		return -1;
	stie_in = synt_none;
	code_immediate(NULL); /* Reserve 0 slot */
	return yyparse() + error_count;
}

NODE *
alloc_node(enum node_type type, const struct locus *locus)
{
	NODE *node = malloc(sizeof(*node));
	if (!node) {
		yyerror("Not enough memory");
		abort();
	}
	node->type = type;
	node->locus = *locus;
	node->next = NULL;
	return node;
}


static struct status_tab {
	mf_status status;
	char *name;
} status_tab[] = {
	{ mf_success, "success" },
	{ mf_not_found, "not_found" },
	{ mf_failure, "failure" }, 
	{ mf_temp_failure, "temp_failure" },

	{ mf_ston_conv, "ston_conv" },
        { mf_divzero, "divzero" },
        { mf_regcomp, "regcomp" },
        { mf_invip, "invip" },
        { mf_invcidr, "invcidr" },
        { mf_invtime, "invtime" },
        { mf_dbfailure, "dbfailure" },
	{ mf_range, "range" },
	{ mf_url, "url" },
	{ 0, NULL }
};

int
string_to_stat(char *str, mf_status *status)
{
	struct status_tab *sp;
	for (sp = status_tab; sp->name; sp++)
		if (strcmp(str, sp->name) == 0) {
			*status = sp->status;
			return 0;
		}
	return 1;
}

const char *
mf_status_str(mf_status stat)
{
	struct status_tab *sp;
	for (sp = status_tab; sp->name; sp++)
		if (sp->status == stat)
			return sp->name;
	return "UNKNOWN";
}


/* Print parse tree */

static void print_node_list(NODE *node, int indent);
static void print_node(NODE *node, int indent);
void print_stat(sfsistat stat);
static int dbg_setreply(void *data, char *code, char *xcode, char *message);
static void dbg_setheader(void *data, struct old_header_node *hdr);

static void
print_level(int level)
{
	level *= 2;
	printf("%*.*s", level, level, "");
}

static void
print_bin_op(enum bin_opcode opcode)
{
	char *p;
	switch (opcode) {
	case bin_and:
		p = "AND";
		break;
		
	case bin_or:
		p = "OR";
		break;
		
	case bin_eq:
		p = "EQ";
		break;
		
	case bin_ne:
		p = "NE";
		break;
		
	case bin_lt:
		p = "LT";
		break;
		
	case bin_le:
		p = "LE";
		break;
		
	case bin_gt:
		p = "GT";
		break;
		
	case bin_ge:
		p = "GE";
		break;
		
	case bin_match:
		p = "MATCH";
		break;
		
	case bin_fnmatch:
		p = "FNMATCH";
		break;

	case bin_add:
		p = "ADD";
		break;
		
	case bin_sub:
		p = "SUB";
		break;
		
	case bin_mul:
		p = "MUL";
		break;
		
	case bin_div:
		p = "DIV";
		break;
		
	default:
		p = "UNKNOWN_OP";
	}
	printf("%s", p);
}

static void
print_node(NODE *node, int level)
{
	switch (node->type) {
	case node_type_string:
		print_level(level);
		printf("CONSTANT: %s\n", node->v.string);
		break;
		
	case node_type_symbol:
		print_level(level);
		printf("SYMBOL: %s\n", node->v.string);
		break;
		
	case node_type_number:
		print_level(level);
		printf("NUMBER: %ld\n", node->v.number);
		break;

	case node_type_backref:
		print_level(level);
		printf("BACKREF: %ld\n", node->v.number);
		break;
		
	case node_type_variable:
		print_level(level);
		printf("VARIABLE %s (%lu)\n", node->v.asgn.var->name,
		       (unsigned long) node->v.asgn.var->off);
		break;

	case node_type_arg:
		print_level(level);
		printf("ARG %lu\n", node->v.number);
		break;

	case node_type_asgn:
		print_level(level);
		printf("SET %s\n", node->v.asgn.var->name);
		print_node(node->v.asgn.node, level + 1);
		break;
		
	case node_type_if:
		print_level(level);
		printf("COND: \n");
		print_node(node->v.cond.cond, level);
		print_level(level);
		printf("IFTRUE\n");
		print_node_list(node->v.cond.if_true, level+1);
		print_level(level);
		printf("IFFALSE\n");
		print_node_list(node->v.cond.if_false, level+1);
		break;

	case node_type_switch:
	{
		struct case_stmt *pcase;
		
		print_level(level);
		printf("SWITCH: \n");
		print_node(node->v.switch_stmt.node, level+1);
		for (pcase = node->v.switch_stmt.cases;
		     pcase; pcase = pcase->next) {
			
			print_level(level+1);
			if (pcase->valist) {
				struct valist *vp;

				printf("CASE ");
				for (vp = pcase->valist; vp; vp = vp->next)
					switch (vp->value.type) {
					case rettype_string:
						printf("\"%s\" ",
						       vp->value.v.string);
						break;
						
					case rettype_number:
						printf("%ld ",
						       vp->value.v.number);
						break;
						
					default:
						abort();
					}
			} else {
				printf("DEFAULT");
			}
			putchar('\n');

			print_level(level+1);
			printf("ACTION\n");
			print_node_list(pcase->node, level+2);
		}
		break;
	}
	
	case node_type_bin:
		print_level(level);
		print_bin_op(node->v.bin.opcode);
		if (node->v.bin.opcode == bin_match
		    || node->v.bin.opcode == bin_fnmatch) {
			if (node->v.bin.qualifier & QUALIFIER_MX)
				printf(",MX");
			if (node->v.bin.qualifier & QUALIFIER_REGFREE)
				printf(",REGFREE");
		}
		printf("\n");
		print_node(node->v.bin.arg[0], level+1);
		print_node(node->v.bin.arg[1], level+1);
		break;

	case node_type_un:
		print_level(level);
		switch (node->v.un.opcode) {
		case unary_not:
			printf("NOT\n");
			break;
		case unary_minus:
			printf("NEG\n");
			break;
		default:
			abort();
		}
		print_node(node->v.un.arg, level+1);
		break;

	case node_type_next:
		print_level(level);
		printf("next\n");
		break;
		
	case node_type_result:
		if (node->v.ret.code) {
		 	char *s = NULL;
			int expr = 0;
			
			print_level(level);
			if (node->v.ret.message) {
				if (node->v.ret.message->type == node_type_string)
					s = node->v.ret.message->v.string;
				else {
					expr = 1;
					s = "(expression)";
				}
			} 
			dbg_setreply(NULL, node->v.ret.code,
				     node->v.ret.xcode,
				     s);
			if (expr) 
				print_node(node->v.ret.message, level+1);
		}
		print_level(level);
		print_stat(node->v.ret.stat);
		printf("\n");
		break;
		
	case node_type_header:
		print_level(level);
		printf("%s %s: \n", header_command_str(node->v.hdr.opcode),
		       node->v.hdr.name);
		print_node_list(node->v.hdr.value, level+1);
		break;

	case node_type_builtin:
	{
		print_level(level);
		printf("BUILTIN %s\n", node->v.builtin.builtin->name);
		print_node_list(node->v.builtin.args, level+1);
		break;
	}

	case node_type_concat:
		print_level(level);
		printf("CONCAT:\n");
		print_node(node->v.concat.arg[0], level+1);
		print_node(node->v.concat.arg[1], level+1);
		break;

	case node_type_push:
		print_level(level);
		printf("PUSH %p:\n", node->v.val);
		break;

	case node_type_regcomp:
		print_level(level);
		printf("REGCOMP:\n");
		print_node(node->v.node, level+1);
		break;

	case node_type_catch:
	{
		int i;
		
		print_level(level);
		printf("CATCH ");
		for (i = 0; i < mf_status_count; i++)
			if (node->v.catch.exmask & EXMASK(i))
				printf("%s ", mf_status_str(i));
		printf("\n");
		print_node_list(node->v.catch.node, level+1);
		printf("END CATCH\n");
		break;
	}

	case node_type_echo:
		print_level(level);
		printf("ECHO:\n");
		print_node(node->v.node, level+1);
		break;

	case node_type_return:
		print_level(level);
		printf("RETURN:\n");
		print_node(node->v.node, level+1);
		break;
		

	case node_type_call:
		print_level(level);
		printf("CALL %s\n", node->v.call.func->name);
		print_node_list(node->v.call.args, level+1);
		break;
		
	default:
		abort();
	}		

}	

static void
print_node_list(NODE *node, int level)
{
	for (; node; node = node->next)
		print_node(node, level);
}

int
function_enumerator(void *sym, void *data)
{
	int i;
	struct function *f = sym;
	
	printf("function %s (", f->name);
	for (i = 0; i < f->parmcount; i++) {
		printf("%s", type_to_string(f->parmtype[i]));
		if (i < f->parmcount-1)
			putchar(',');
	}
	putchar(')');
	if (f->rettype != rettype_unspecified)
		printf(" returns %s", type_to_string(f->rettype));
	printf(":\n");
	print_node_list(f->node, 0);
	printf("END function %s\n", f->name);
	return 0;
}
		
void
print_config()
{
	enum smtp_state tag;
	printf("State handlers:\n");
	printf("---------------\n");
	for (tag = smtp_state_first; tag < smtp_state_count; tag++) {
		if (root_node[tag]) {
			printf("%s:\n", state_to_string(tag));
			print_node_list(root_node[tag], 0);
			putchar('\n');
		}
	}
	printf("User functions:\n");
	printf("---------------\n");
	symbol_enumerate(SYM_FUNC, function_enumerator, NULL);
}


static mu_list_t macro_list[smtp_state_count];

void
register_macro(enum smtp_state tag, char *macro)
{
	if (!config_dump_macros)
		return;
	if (!macro_list[tag]) {
		mu_list_create(&macro_list[tag]);
		mu_list_set_comparator(macro_list[tag], compare_string);
	}
	if (mu_list_locate(macro_list[tag], macro, NULL)) 
		mu_list_append(macro_list[tag], macro);
}

static int
print_macro(void *item, void *data)
{
	int *p = data;
	if (*p) {
		printf(" ");
		*p = 0;
	} else
		printf(", ");
	printf("%s", item);
	return 0;
}


void
print_used_macros()
{
	enum smtp_state tag;
	
	for (tag = smtp_state_first; tag < smtp_state_count; tag++) {
		if (macro_list[tag]) {
			int n = 1;
			printf("%s", state_to_string(tag));
			mu_list_do(macro_list[tag], print_macro, &n);
			printf("\n");
		}
	}
}


/* Code generation */
int errors;

#define __code_cat3__(a,b,c) a ## b ## c

#define CODE_BINARY(ltype, rtype, op, node) do {                              \
	if (ltype != rtype) {                                                 \
		if (code_cast(&node->locus, rtype, ltype))                    \
			return rettype_unspecified;                           \
	}                                                                     \
	switch (ltype) {                                                      \
	case rettype_number:                                                  \
		code_instr(__code_cat3__(instr_,op,n));                       \
		break;                                                        \
	case rettype_string:                                                  \
		code_instr(__code_cat3__(instr_,op,s));                       \
		break;                                                        \
	default:                                                              \
		parse_error_locus(&node->locus,                               \
				"Invalid argument type in binary operation"); \
		break;                                                        \
	}                                                                     \
} while (0)

int
code_cast(struct locus *locus, instr_rettype fromtype, instr_rettype totype)
{
	if (fromtype == totype) {
		if (totype == rettype_string)
			code_instr(instr_svalidate);
		
		return 0;
	}
	
	switch (fromtype) {
	case rettype_unspecified:
		parse_error_locus(locus,
				  "Expression evaluates to unspecified data type");
		errors = 1;
		return 1;

	case rettype_string:
		code_instr(instr_svalidate);
		code_instr(instr_ston);
		break;
		
	case rettype_number:
		code_instr(instr_ntos);
		break;
	}
	return 0;
}

static void traverse_tree(NODE *node);
static instr_rettype code_node(NODE *node);

static void
jump_fixup(prog_counter_t pos, prog_counter_t endpos)
{
	while (pos) {
		prog_counter_t next = (prog_counter_t)code_peek(pos);
		code_put(pos, (void*)(endpos - pos - 1));
		pos = next;
	}
}

/* The following code is generated for switch statements:
   
	popreg      ; Pop the result of the previous instruction into the reg
	xlat        ; Look up in the table and replace reg with the new value
	            ; If the switch selector is of string type, xlats is
		    ; coded instead
	N           ; Number of elements in the xlat table
	key1        ; First key 
	off1        ; Corresponding jump offset, relative to L0
	key2        ; Second key
	off2        ; Corresponding jump offset, relative to L0 
	.
	.
	.
	keyN
	offN
	bnz L1      ; If xlat failed, jump to the default case
L0:	jreg        ; Jump to the selected branch 
L1:	
	...         ; Default case
L0+off1:
        ...         ; First branch
	jmp L2
L0+off2:
        ...         ; Second branch
	jmp L2
	.
	.
	.
L0+offN:
        ...         ; Nth branch
L2:	
*/
static void
code_switch_branches(NODE *node, instr_rettype type)
{
	prog_counter_t start, refpos, jmppos;
	struct case_stmt *pcase;
	size_t tabsize = 0;

	/* Compute the table size and convert all key values
	   to type */
	for (pcase = node->v.switch_stmt.cases;
	     pcase;
	     pcase = pcase->next) {
		struct valist *vp;
		long v;
		char *p;

		for (vp = pcase->valist; vp; vp = vp->next) {
			tabsize++;
			if (vp->value.type != type) {
				char buf[NUMERIC_BUFSIZE_BOUND];

				/* FIXME: The following code is very crude */
				switch (type) {
				case rettype_number:
					v = strtol(vp->value.v.string, &p, 0);
					if (*p) {
						parse_error_locus(&pcase->locus,
						"cannot convert %s to number",
							vp->value.v.string);
						errors = 1;
						return;
					}
					vp->value.v.number = v;
					break;

				case rettype_string:
					snprintf(buf, sizeof buf, "%ld",
						 vp->value.v.number);
					vp->value.v.string = strdup(buf);
					break;

				default:
					abort();
				}
			}
		}
	}

	code_instr(instr_popreg);
	code_instr(type == rettype_number ? instr_xlat : instr_xlats);
	start =	code_reserve(2*tabsize+1);
	code_instr(instr_bnz);
	code_immediate((void*)1);
	refpos = code_instr(instr_jreg);
		
	/* Generate code for the branches */
	jmppos = 0;
	code_put(start, (void*)tabsize);
	start++;
	for (pcase = node->v.switch_stmt.cases;
	     pcase;
	     pcase = pcase->next) {
		struct valist *vp;
		prog_counter_t pos;
		
		pos = code_get_counter() - refpos;
		traverse_tree(pcase->node);
		if (pcase->next) {
			code_instr(instr_jmp);
			jmppos = code_immediate((void*)jmppos);
		}
		for (vp = pcase->valist; vp; vp = vp->next) {
			code_put(start, (void*)vp->value.v.string);
			code_put(start+1, (void*)pos);
			start += 2;
		}
	}

	/* Fix up jump offsets */
	jump_fixup(jmppos, code_get_counter());
}
	
static void
code_switch(NODE *node)
{
	instr_rettype type;
	
	type = code_node(node->v.switch_stmt.node);
	if (type == rettype_unspecified) {
		errors = 1;
		return;
	}
	code_switch_branches(node, type);
}
		
#define LOCUS_EQ(a,b) \
 (strcmp((a)->file, (b)->file) == 0 && (a)->line == (b)->line)

static instr_rettype
code_node(NODE *node)
{
	instr_rettype ltype, rtype;
	prog_counter_t pos1, pos2, endpos;
	static struct locus *old_locus;

#define MARK_LOCUS()                                                 \
	do if (!old_locus || !LOCUS_EQ(old_locus, &node->locus)) {   \
		old_locus = &node->locus;                            \
		code_instr(instr_locus);                             \
		code_immediate(node->locus.file);                    \
		code_immediate((void*)node->locus.line);             \
	} while (0)

	switch (node->type) {
	case node_type_string:
		MARK_LOCUS();
		code_instr(instr_push_immediate);
		code_immediate(node->v.string);
		return rettype_string;

	case node_type_number:
		MARK_LOCUS();
		code_instr(instr_push_immediate);
		code_immediate((void*)node->v.number);
		return rettype_number;
		
	case node_type_symbol:
		MARK_LOCUS();
		code_instr(instr_symbol);
		code_immediate(node->v.string);
		return rettype_string;

	case node_type_variable:
		MARK_LOCUS();
		code_instr(instr_variable);
		code_immediate((void*)node->v.variable->off);
		return node->v.variable->type;

	case node_type_backref:
		MARK_LOCUS();
		code_instr(instr_backref);
		code_immediate((void*)node->v.number);
		return rettype_string;
		
	case node_type_arg:
		MARK_LOCUS();
		code_instr(instr_arg);
		code_immediate((void*)node->v.number);
		return PARMTYPE(node->v.number);
		
	case node_type_asgn:
		ltype = code_node(node->v.asgn.node);
		node->v.variable->type = ltype;
		code_instr(instr_asgn);
		code_immediate((void*)node->v.variable->off);
		return ltype;
			
	case node_type_if:
		code_node(node->v.cond.cond);
		MARK_LOCUS();
		code_instr(instr_bz);
		pos1 = code_immediate(NULL);
		traverse_tree(node->v.cond.if_true);
		if (node->v.cond.if_false) {
			code_instr(instr_jmp);
			pos2 = code_immediate(NULL);
			traverse_tree(node->v.cond.if_false);
			endpos = code_get_counter ();
			code_put(pos1, (void *)(pos2 - pos1));
			code_put(pos2, (void *)(endpos - pos2 - 1));
		} else 
			code_put(pos1, (void *)(code_get_counter () - pos1 - 1));
		break;

	case node_type_bin:
		ltype = code_node(node->v.bin.arg[0]);

		switch (node->v.bin.opcode) {
		case bin_and:
			MARK_LOCUS();
			/* cond1                        
			   if not true goto X
			   cond2
			   if true goto Y
			X: push 0
			   goto Z
			Y: push 1
                        Z: */
			if (code_cast(&node->locus, ltype, rettype_number))
				return rettype_unspecified;
			code_instr(instr_bz);
			pos1 = code_immediate(NULL);
			rtype = code_node(node->v.bin.arg[1]);
			if (code_cast(&node->locus, rtype, rettype_number))
				return rettype_unspecified;
			code_instr(instr_bnz);
			pos2 = code_immediate((void *)4);
			code_instr(instr_push_immediate);
			code_immediate((void *)0);
			code_instr(instr_jmp);
			code_immediate((void *)2);
			code_instr(instr_push_immediate);
			code_immediate((void*)1);
			code_put(pos1, (void *)(pos2 - pos1));
			return rettype_number;
			
		case bin_or:
			MARK_LOCUS();
			/* cond1                        
			   if true goto X
			   cond2
			   if not true goto Y
			X: push 1
			   goto Z
			Y: push 0
                        Z: */

			if (code_cast(&node->locus, ltype, rettype_number))
				return rettype_unspecified;
			code_instr(instr_bnz);
			pos1 = code_immediate(NULL);
			rtype = code_node(node->v.bin.arg[1]);
			if (code_cast(&node->locus, rtype, rettype_number))
				return rettype_unspecified;
			code_instr(instr_bz);
			pos2 = code_immediate((void *)4);
			code_instr(instr_push_immediate);
			code_immediate((void *)1);
			code_instr(instr_jmp);
			code_immediate((void *)2);
			code_instr(instr_push_immediate);
			code_immediate((void *)0);
			code_put(pos1, (void *)(pos2 - pos1));
			return rettype_number;

		case bin_eq:
			rtype = code_node(node->v.bin.arg[1]);
			CODE_BINARY(ltype, rtype, eq, node);
			return rettype_number;
			
		case bin_ne:
			rtype = code_node(node->v.bin.arg[1]);
			CODE_BINARY(ltype, rtype, ne, node);
			return rettype_number;

		case bin_lt:
			rtype = code_node(node->v.bin.arg[1]);
			CODE_BINARY(ltype, rtype, lt, node);
			return rettype_number;
			
		case bin_le:
			rtype = code_node(node->v.bin.arg[1]);
			CODE_BINARY(ltype, rtype, le, node);
			return rettype_number;

		case bin_gt:
			rtype = code_node(node->v.bin.arg[1]);
			CODE_BINARY(ltype, rtype, gt, node);
			return rettype_number;

		case bin_ge:
			rtype = code_node(node->v.bin.arg[1]);
			CODE_BINARY(ltype, rtype, ge, node);
			return rettype_number;
			
		case bin_match:
			if (code_cast(&node->locus, ltype, rettype_string))
				return rettype_unspecified;
			rtype = code_node(node->v.bin.arg[1]);
			if (code_cast(&node->locus, rtype, rettype_string))
				return rettype_unspecified;
			code_instr(instr_push_immediate);
			code_immediate((void*) (node->v.bin.qualifier &
						 QUALIFIER_REGFREE));
			MARK_LOCUS();
			if (node->v.bin.qualifier & QUALIFIER_MX)
				code_instr(instr_regex_mx);
			else
				code_instr(instr_regex);
			return rettype_number;

		case bin_fnmatch:
			if (code_cast(&node->locus, ltype, rettype_string))
				return rettype_unspecified;
			rtype = code_node(node->v.bin.arg[1]);
			if (code_cast(&node->locus, rtype, rettype_string))
				return rettype_unspecified;
			MARK_LOCUS();
			if (node->v.bin.qualifier & QUALIFIER_MX)
				code_instr(instr_fnmatch_mx);
			else
				code_instr(instr_fnmatch);
			return rettype_number;

		case bin_add:
			if (code_cast(&node->locus, ltype, rettype_number))
				return rettype_unspecified;
			rtype = code_node(node->v.bin.arg[1]);
			if (code_cast(&node->locus, rtype, rettype_number))
				return rettype_unspecified;
			MARK_LOCUS();
			code_instr(instr_add);
			return rettype_number;
			
		case bin_sub:
			if (code_cast(&node->locus, ltype, rettype_number))
				return rettype_unspecified;
			rtype = code_node(node->v.bin.arg[1]);
			if (code_cast(&node->locus, rtype, rettype_number))
				return rettype_unspecified;
			MARK_LOCUS();
			code_instr(instr_sub);
			return rettype_number;
			
		case bin_mul:
			if (code_cast(&node->locus, ltype, rettype_number))
				return rettype_unspecified;
			rtype = code_node(node->v.bin.arg[1]);
			if (code_cast(&node->locus, rtype, rettype_number))
				return rettype_unspecified;
			MARK_LOCUS();
			code_instr(instr_mul);
			return rettype_number;
			
		case bin_div:
			if (code_cast(&node->locus, ltype, rettype_number))
				return rettype_unspecified;
			rtype = code_node(node->v.bin.arg[1]);
			if (code_cast(&node->locus, rtype, rettype_number))
				return rettype_unspecified;
			MARK_LOCUS();
			code_instr(instr_div);
			return rettype_number;
			
		default:
			break;
		}
		return rettype_unspecified;

	case node_type_regcomp:
		ltype = code_node(node->v.node);
		if (code_cast(&node->locus, ltype, rettype_string))
			return rettype_unspecified;
		code_instr(instr_regcomp);
		return rettype_string;

	case node_type_push:
		code_instr(instr_push_immediate);
		code_immediate(node->v.val);
		return rettype_string; /* FIXME */
		
	case node_type_un:
		ltype = code_node(node->v.un.arg);
		if (code_cast(&node->locus, ltype, rettype_number))
			return rettype_unspecified;
		MARK_LOCUS();
		switch (node->v.un.opcode) {
		case unary_not:
			code_instr(instr_not);
			break;
			
		case unary_minus:
			code_instr(instr_neg);
			break;

		default:
			abort();
		}
		return rettype_number;

	case node_type_next:
		MARK_LOCUS();
		code_instr(instr_next);
		break;

	case node_type_result:
		if (node->v.ret.message)
			code_node(node->v.ret.message);
		else {
			code_instr(instr_push_immediate);
			code_immediate(NULL);
		}
		MARK_LOCUS();
		code_instr(instr_result);
		code_immediate((void*)node->v.ret.stat);
		code_immediate(node->v.ret.code);
		code_immediate(node->v.ret.xcode);
		code_instr(NULL);
		break;

	case node_type_header:
		MARK_LOCUS();
		ltype = code_node(node->v.hdr.value);
		if (code_cast(&node->locus, ltype, rettype_string))
			return rettype_unspecified;
		code_instr(instr_header);
		code_immediate((void*)node->v.hdr.opcode);
		code_immediate(node->v.hdr.name);
		break;

	case node_type_builtin:
	{
		NODE *p;
		int i;

		for (i = 0, p = node->v.builtin.args; p; i++, p = p->next) {
			ltype = code_node(p);
			if (code_cast(&node->locus, ltype,
				      node->v.builtin.builtin->parmtype[i]))
				errors = 1;
		}
		MARK_LOCUS();
		code_instr(instr_builtin);
		code_immediate(node->v.builtin.builtin->name);
		code_immediate(node->v.builtin.builtin->handler);
		return node->v.builtin.builtin->rettype;
	}

	case node_type_call:
	{
		NODE *p;
		int i;

		for (i = 0, p = node->v.call.args; p; i++, p = p->next) {
			ltype = code_node(p);
			if (code_cast(&node->locus, ltype,
				      node->v.call.func->parmtype
				           [node->v.call.func->parmcount-i-1]))
				errors = 1;
		}
		MARK_LOCUS();
		code_instr(instr_funcall);
		code_immediate(node->v.call.func->name);
		code_immediate((void*)node->v.call.func->entry);
		code_instr(instr_adjust);
		code_immediate((void*)node->v.call.func->parmcount);
		if (node->v.call.func->rettype != rettype_unspecified)
			code_instr(instr_pushreg);
		return node->v.call.func->rettype;
	}
		
	case node_type_concat:
		ltype = code_node(node->v.concat.arg[0]);
		if (code_cast(&node->v.concat.arg[0]->locus, ltype,
			      rettype_string))
			return rettype_unspecified;
		rtype = code_node(node->v.concat.arg[1]);
		if (code_cast(&node->v.concat.arg[1]->locus, rtype, rettype_string))
			return rettype_unspecified;
		code_instr(instr_concat);
		return rettype_string;

	case node_type_catch:
	{
		int old_tie_in;
		prog_counter_t ctr;
		
		MARK_LOCUS();
		code_instr(instr_catch);
		pos1 = code_immediate(NULL);
		code_immediate((void*)node->v.catch.count);
		code_immediate((void*)node->v.catch.exmask);
		old_tie_in = stie_in;
		stie_in = synt_catch;
		ctr = jump_pc;
		jump_pc = 0;

		traverse_tree(node->v.catch.node);
		jump_fixup(jump_pc, code_get_counter());
		
		jump_pc = ctr;
		stie_in = old_tie_in;

		code_instr(instr_retcatch);
		if (stie_in == synt_function) {
			code_instr(instr_adjust);
			code_immediate((void*)1);
			code_instr(instr_jmp);
			jump_pc = code_immediate((void*)jump_pc);
		} else {
			code_instr(instr_push_immediate);
                        code_immediate(NULL);
			code_instr(instr_result);
			code_immediate(SMFIS_CONTINUE);
			code_immediate(NULL);
			code_immediate(NULL);
			code_immediate(NULL);
		}

		endpos = code_get_counter ();
		code_put(pos1, (void *)(endpos - pos1));

		break;
	}

	case node_type_echo:
		ltype = code_node(node->v.node);
		if (code_cast(&node->locus, ltype, rettype_string))
			return rettype_unspecified;
		MARK_LOCUS();
		code_instr(instr_echo);
		break;

	case node_type_return:
		if (!func) {
			parse_error_locus(&node->locus,
					  "`return' outside of a function");
			errors = 1;
		} else if (func->rettype == rettype_unspecified) {
			if (node->v.node) {
				parse_error_locus(&node->locus,
				       "`return' with a value, in function "
				       "returning void");
				errors = 1;
			}
			MARK_LOCUS();
			code_instr(instr_jmp);
			jump_pc = code_immediate((void*)jump_pc);
		} else if (node->v.node == NULL) {
			parse_error_locus(&node->locus,
					"`return' with no value, in function "
					"returning non-void");
			errors = 1;
		} else {
			ltype = code_node(node->v.node);
			if (code_cast(&node->v.node->locus, ltype,
				      func->rettype))
				return rettype_unspecified;
			MARK_LOCUS();
			code_instr(instr_popreg);
			code_instr(instr_jmp);
			jump_pc = code_immediate((void*)jump_pc);
			return func->rettype;
		}
		break;

	case node_type_switch:
		code_switch(node);
		break;
		
	default:
		abort();
	}
	return rettype_unspecified;
}

static void
traverse_tree(NODE *node)
{
	for (; node; node = node->next)
		code_node(node);
}

static void optimize(NODE *node);

static void
optimize_node(NODE *node)
{
	int i;
	NODE *p;
	
	switch (node->type) {
	case node_type_bin:
		optimize(node->v.bin.arg[0]);
		optimize(node->v.bin.arg[1]);
		if (node->v.bin.opcode == bin_match) {
			if (node->v.bin.arg[1]->type == node_type_string) {
				int rc;
				regex_t *regex;
				NODE *p = alloc_node(node_type_push,
						     &node->locus);

				regex = emalloc(sizeof *regex);
				rc = regcomp(regex,
					     node->v.bin.arg[1]->v.string,
					     regex_flags);
				if (rc) {
					char errbuf[512];
					regerror(rc,
						 regex, errbuf,
						 sizeof(errbuf));
					parse_error_locus(&node->locus,
						   "Cannot compile regex: %s",
							  errbuf);
					error_count++;
					free(regex);
					break;
				}
				p->v.val = regex;
				node->v.bin.arg[1] = p;
			} else {
				NODE *p = alloc_node(node_type_regcomp,
						     &node->locus);
				p->v.node = node->v.bin.arg[1];
				node->v.bin.arg[1] = p;
				node->v.bin.qualifier |= QUALIFIER_REGFREE;
			}
		}
		break;
		
	case node_type_if:
		optimize(node->v.cond.cond);
		optimize(node->v.cond.if_true);
		optimize(node->v.cond.if_false);
		break;

	case node_type_un:
		optimize(node->v.un.arg);
		break;

	case node_type_asgn:
		optimize(node->v.asgn.node);
		break;

	case node_type_result:
		optimize(node->v.ret.message);
		break;

	case node_type_builtin:
		for (i = 0, p = node->v.builtin.args; p; i++, p = p->next) 
			optimize(p);
		if (strcmp(node->v.builtin.builtin->name, "interval") == 0) {
			if (node->v.builtin.args->type ==
			    node_type_string) {
				time_t t;
				char *endp;
				
				if (parse_time_interval(
					    node->v.builtin.args->v.string,
					    &t, &endp)) {
					parse_error_locus(&node->locus,
					"unrecognized time format (near `%s')",
							  endp);
					error_count++;
					break;
				}
				/* Replace this node */
				node->type = node_type_number;
				node->v.number = t;
			}
		}
		break;

	case node_type_concat:
		optimize(node->v.concat.arg[0]);
		optimize(node->v.concat.arg[1]);
		break;

	case node_type_catch:
		optimize(node->v.catch.node);
		break;

	case node_type_echo:
	case node_type_return:
		optimize(node->v.node);
		break;

	case node_type_switch:
	{
		struct case_stmt *pcase;
		
		optimize(node->v.switch_stmt.node);
		for (pcase = node->v.switch_stmt.cases;
		     pcase; pcase = pcase->next) 
			optimize(pcase->node);
		break;
	}

	case node_type_header:
		optimize(node->v.hdr.value);
		break;
	
	default:
		break;
	}
}

static void
optimize(NODE *node)
{
	for (; node; node = node->next)
		optimize_node(node);
}

static int
codegen(prog_counter_t *pc, NODE *node)
{
	*pc = code_get_counter();
	errors = 0;
	jump_pc = 0;
	optimize(node);
	traverse_tree(node);
	code_instr(NULL);
	return errors;
}



#define skip_ws(p) while (*(p) && isspace(*(p))) (p)++;
			  
static char *
getword(char **p, char **buf)
{
	int len;
	
	skip_ws(*p);
	if (!**p)
		return NULL;
	for (len = 0; (*p)[len] && !isspace((*p)[len]); len++)
		;
	*buf = malloc(len+1);
	if (*buf) {
		memcpy(*buf, *p, len);
		(*buf)[len] = 0;
	}
	*p += len;
	return *buf;
}

enum regex_mode { regex_enable, regex_disable, regex_set };

static void
pragma_regex(char *text)
{
	char *p, *buf;
	int bit;
	enum regex_mode mode = regex_set;
	
	while (p = getword(&text, &buf)) {
		switch (p[0]) {
		case '+':
			mode = regex_enable;
			p++;
			break;

		case '-':
			mode = regex_disable;
			p++;
			break;

		case '=':
			mode = regex_set;
			p++;
			break;
		}

		if (strcmp (p, "extended") == 0)
			bit = REG_EXTENDED;
		else if (strcmp (p, "icase") == 0)
			bit = REG_ICASE;
		else if (strcmp (p, "newline") == 0)
			bit = REG_NEWLINE;
		else {
			parse_error("Unknown regexp flag: %s", p);
			free(buf);
			return;
		}

		switch (mode) {
		case regex_disable:
			regex_flags &= ~bit;
			break;
		case regex_enable:
			regex_flags |= bit;
			break;
		case regex_set:
			regex_flags = bit;
			break;
		}
		free(buf);
	}
}

static void
pragma_option(char *text)
{
	char *name;
	char *value;
	char *p;
	int len;
	
	if (!getword(&text, &name)) {
		parse_error("Invalid pragma: expected option name");
		return;
	}

#define EXPIRE_SUFFIX 	"expire-interval"
#define EXPIRE_SUFFIX_LEN (sizeof(EXPIRE_SUFFIX)-1)

#define TIMEOUT_SUFFIX  "timeout"
#define TIMEOUT_SUFFIX_LEN (sizeof(TIMEOUT_SUFFIX)-1)

	if (strcmp(name, "mailfrom") == 0
	    || (strlen(name) >= EXPIRE_SUFFIX_LEN
		&& strcmp(name + strlen(name) - EXPIRE_SUFFIX_LEN,
			  EXPIRE_SUFFIX) == 0)
	    || (strlen(name) >= TIMEOUT_SUFFIX_LEN
		&& strcmp(name + strlen(name) - TIMEOUT_SUFFIX_LEN,
			  TIMEOUT_SUFFIX) == 0)) {
		/* Special handling for expire and timeout intervals */
		value = strdup(text);
		text += strlen(text);
	} else if (!getword(&text, &value)) {
		parse_error("Invalid pragma: expected option value");
		free(name);
		return;
	}

	skip_ws(text);
	if (*text) {
		parse_error("Invalid pragma: junk after the arguments");
		/* Try to handle it anyway */
	}

	p = value;
	len = strlen(p);
	if ((*p == '"' || *p == '\'') && p[len-1] == *p) {
		p[len-1] = 0;
		p++;
	}
		
	if (set_option(name, p, 0)) {
		if (errno == ENOENT)
			parse_error("Unknown pragma option");
		else
			parse_error("Invalid pragma");
	}
	
	free(name);
	free(value);
}

static void
pragma_stacksize(char *text)
{
	char *p;
	stack_size = strtoul(text, &p, 0);
	if (*p) {
		for (; *p; p++) 
			if (!(isascii(*p) && isspace(*p))) {
				parse_error("Invalid pragma: junk after stack size");
				return;
			}
	}
}

static int
get_interval(char *text, time_t *pinterval)
{
	char *endp;
	time_t interval;

	while (*text && isspace(*text))
		text++;
	if (!*text) {
		parse_error("Invalid pragma: unexpected end of line");
		return 1;
	}
	if (parse_time_interval(text, &interval, &endp)) {
		parse_error("Invalid pragma: unrecognized time format "
			    "(near `%s')",
			    endp);
		return 1;
	}
	*pinterval = interval;
	return 0;
}

/* #pragma database FMTNAME file FILENAME
   #pragma database FMTNAME expire-interval INTERVAL
   #pragma database cache positive-expire-interval INTERVAL
   #pragma database cache negative-expire-interval INTERVAL
*/
static void
pragma_database(char *text)
{
	char *fmtname;
	char *kw;
	struct db_format *fmt;
	
	if (!getword(&text, &fmtname)) {
		parse_error("Invalid pragma: expected database name");
		return;
	}
	if ((fmt = db_format_lookup(fmtname)) == NULL) {
		parse_error("unknown database format: %s", fmtname);
		return;
	}
	if (!getword(&text, &kw)) {
		parse_error("Invalid pragma: expected keyword");
		return;
	}
	if (strcmp(kw, "file") == 0) {
		char *value;
		char *p;
		int len;
		
		if (!getword(&text, &value)) {
			parse_error("Invalid pragma: expected file name");
			return;
		}
		p = value;
		len = strlen(p);
		if ((*p == '"' || *p == '\'') && p[len-1] == *p) {
			p[len-1] = 0;
			p++;
		}
		fmt->dbname = strdup(p);
	} else if (strcmp(kw, "expire-interval") == 0) {
		get_interval(text, &fmt->expire_interval);
	} else if (strcmp(kw, "positive-expire-interval") == 0) {
		if (fmt != cache_format) {
			parse_error("positive-expire-interval is valid only for cache database");
			return;
		}
		get_interval(text, &fmt->expire_interval);
	} else if (strcmp(kw, "negative-expire-interval") == 0) {
		if (fmt != cache_format) {
			parse_error("negative-expire-interval is valid only for cache database");
			return;
		}
		get_interval(text, &negative_expire_interval);
	} else {
		parse_error("Invalid pragma: unrecognized keyword: %s", kw);
		return;
	}
}

void
parse_pragma(char *text)
{
	char *buf;

	while (*text != '#')
		text++;
	++text;
	skip_ws(text);
	text += 6; /* "pragma" */

	if (!getword(&text, &buf))
		parse_error("Empty pragma");
	else if (strcmp(buf, "regex") == 0)
		pragma_regex(text);
	else if (strcmp(buf, "database") == 0)
		pragma_database(text);
	else if (strcmp(buf, "option") == 0)
		pragma_option(text);
	else if (strcmp(buf, "stacksize") == 0)
		pragma_stacksize(text);
	else
		parse_error("Unknown pragma");
	free(buf);
}


/* Test run */
struct sfsistat_tab {
	char *name;
	sfsistat stat;
} sfsistat_tab[] = {
	{ "accept", SMFIS_ACCEPT },
	{ "continue", SMFIS_CONTINUE },
	{ "discard", SMFIS_DISCARD },
	{ "reject", SMFIS_REJECT },
	{ "tempfail", SMFIS_TEMPFAIL },
	{ NULL }
};

const char *
sfsistat_str(sfsistat stat)
{
	struct sfsistat_tab *p;
	for (p = sfsistat_tab; p->name; p++)
		if (p->stat == stat) 
			return p->name;
	return NULL;
}

void
print_stat(sfsistat stat)
{
	struct sfsistat_tab *p;
	for (p = sfsistat_tab; p->name; p++)
		if (p->stat == stat) {
			printf("%s", p->name);
			return;
		}
	printf("%d", stat);
}

const char *
header_command_str(enum header_opcode opcode)
{
	switch (opcode) {
	case header_add:
		return "ADD HEADER ";
		
	case header_replace:
		return "REPLACE HEADER ";
		break;

	case header_delete:
		return "DELETE HEADER ";
		break;
	}
	return "UNKNOWN HEADER COMMAND ";
}

static int
dbg_setreply(void *data, char *code, char *xcode, char *message)
{
	if (code) {
		printf("SET REPLY %s", code);
		if (xcode)
			printf(" %s", xcode);
		if (message)
			printf(" %s", message);
		printf("\n");
	}
	return 0;
}

static void
dbg_setheader(void *data, struct old_header_node *hdr)
{
	printf("%s %s: %s\n", header_command_str(hdr->opcode), hdr->name,
	       hdr->value);
}

void
mailfromd_test(int argc, char **argv)
{
	int i, rc;
	mu_list_t dict = NULL;
	eval_environ_t env;
	char *p, *end;
	long n;
	sfsistat status;
	char *args[9] = {0,0,0,0,0,0,0,0,0};
		
	dict_init(&dict);
	env = create_environment(NULL,
				 dict_getsym, dbg_setreply, dbg_setheader,
				 dict);
	env_init(env);
	for (i = 0; i < argc; i++) {
		if (p = strchr(argv[i], '=')) {
			char *ident = argv[i];
			*p++ = 0;
			if (*ident == '%') 
				env_set_variable(env, ident+1, p);
			else if (isdigit(*ident) && *ident != 0
				 && ident[1] == 0) 
				args[*ident - '0' - 1] = p;
			else 
				dict_install(dict, argv[i], p);
		}
	}

	for (i = state_parms[test_state].cnt; i--; ) {
		switch (state_parms[test_state].types[i]) {
		case rettype_string:
			env_push_string(env, args[i] ? args[i] : "");
			break;
		case rettype_number:
			n = strtol(p, &end, 0);
			if (*end) 
				mu_error("$%d is not a number", i+1);
			env_push_number(env, n);
			break;
		default:
			abort();
		}
	}
	env_make_frame(env);
	rc = xeval(env, test_state);
	env_leave_frame(env, state_parms[test_state].cnt);
	status = environment_get_status(env);
	printf("State %s: ", state_to_string(test_state));
	print_stat(status);
	printf("\n");
	destroy_environment(env);
}

void
set_poll_arg(struct poll_data *poll, int kw, NODE *expr)
{
	switch (kw) {
	case FOR:
		poll->email = expr;
		break;
		
	case HOST:
		poll->client_addr = expr;
		break;
		
	case AS:
		poll->mailfrom = expr;
		break;
		
	case FROM:
		poll->ehlo = expr;
		break;
		
	default:
		abort();
	}
}
		
static int
time_multiplier(const char *str, unsigned *m, unsigned *plen)
{
	static struct timetab {
		char *name;
		unsigned mul;
	} tab[] = {
		{ "seconds", 1 },
		{ "minutes", 60 },
		{ "hours", 60*60 },
		{ "days",  24*60*60 },
		{ "weeks", 7*24*60*60 },
		{ "months", 31*7*24*60*60 },
		{ NULL }
	};
	struct timetab *p;
	int slen;

	for (slen = 0; str[slen]; slen++)
		if (isspace(str[slen]))
			break;

	for (p = tab; p->name; p++) {
		if (p->name[0] == tolower(str[0])) {
			int nlen = strlen(p->name);

			if (nlen > slen)
				nlen = slen;
			
			if (strncasecmp(p->name, str, nlen) == 0) {
				*m = p->mul;
				if (plen)
					*plen = nlen;
				return 0;
			}
		}
	}
	return 1;
}

int
parse_time_interval(char *str, time_t *pint, char **endp)
{
	int rc = 0;
	time_t interval = 0;
	
	while (*str) {
		char *p;
		unsigned long n;
		unsigned mul, len;

		while (*str && isspace(*str))
			str++;

		if (!isdigit(*str) && time_multiplier(str, &mul, &len) == 0) {
			n = 1;
			str += len;
		} else {
			n = strtoul(str, &p, 10);
			if (*p && !isspace(*p)) {
				str = p;
				rc = 1;
				break;
			}

			while (*p && isspace(*p))
				p++;

			str = p;
			if (*str) {
				if (rc = time_multiplier(str, &mul, &len))
					break;
				str += len;
			} else
				mul = 1;
		}
		interval += n*mul;
	}

	if (rc && endp)
		*endp = str;
	*pint = interval;
	return rc;
}

int
convert_rate(const char *arg, double *rate)
{
	double count;
	char *p;

	count = strtod(arg, &p);
	if (*p) {
		time_t div;
		char *endp;

		while (*p && isspace(*p))
			p++;
		if (isalpha(*p)) {
			if (strcmp(p, "per") == 0 && isspace(p[3]))
				p += 3;
		} else if (ispunct(*p))
			p++;

		if (parse_time_interval(p, &div, &endp)) {
			mu_error("unrecognized time format (near `%s')",
				 endp);
			return 1;
		}
		count /= div;
	}
	*rate = count;
	return 0;
}
		
static struct tagtable {
	char *name;
	enum smtp_state tag;
} tagtable[] = {
	{ "connect", smtp_state_connect },
	{ "helo", smtp_state_helo },  
	{ "envfrom", smtp_state_envfrom }, 
	{ "envrcpt", smtp_state_envrcpt }, 
	{ "header", smtp_state_header }, 
	{ "eoh", smtp_state_eoh }, 
	{ "body", smtp_state_body }, 
	{ "eom", smtp_state_eom },
};

enum smtp_state
string_to_state(char *name)
{
	struct tagtable *p;

	for (p = tagtable; p < tagtable + sizeof tagtable/sizeof tagtable[0];
	     p++)
		if (strcasecmp (p->name, name) == 0)
			return p->tag;

	return smtp_state_none;
}

const char *
state_to_string(enum smtp_state state)
{
	if (state-1 < sizeof tagtable/sizeof tagtable[0])
		return tagtable[state-1].name;
	abort();
}


struct variable *
builtin_variable_install(const char *name, instr_rettype type)
{
	struct variable *var = variable_install(name);
	var->type = type;
	var->off = variable_count++;
	return var;
}

static NODE *
_reverse(NODE *list, NODE **root)
{
	NODE *next;

	if (list->next == NULL) {
		*root = list;
		return list;
	}
	next = _reverse(list->next, root);
	next->next = list;
	list->next = NULL;
	return list;
}		

NODE *
reverse(NODE *in)
{
	NODE *root;
	_reverse(in, &root);
	return root;
}


static NODE *
create_on_node(NODE *sel, struct case_stmt *cases)
{
	struct case_stmt *cur;
	unsigned mask = 0;
	char nbuf[NUMERIC_BUFSIZE_BOUND];
	struct function *fp;
	const char *base_name;
	char *fname;
	size_t size;
	int count = 0;
	int argc;
	NODE *args;
	instr_rettype *ptypes, rettype;
	NODE *call_node, *retnode;
		     
	/* Create a list of exceptions to catch */
	for (cur = cases; cur; cur = cur->next) {
		struct valist *vp;
		for (vp = cur->valist; vp; vp = vp->next) {
			mask |= EXMASK(vp->value.v.number);
			count++;
		}
	}

	/* Check if we already have a wrapper function */
	snprintf(nbuf, sizeof nbuf, "%u", mask);
	switch (sel->type) {
	case node_type_builtin:
		base_name = sel->v.builtin.builtin->name;
		argc = sel->v.builtin.builtin->parmcount;
		args = reverse(sel->v.builtin.args);
		ptypes = sel->v.builtin.builtin->parmtype;
		rettype = sel->v.builtin.builtin->rettype;
		break;
	case node_type_call:
		base_name = sel->v.call.func->name;
		argc = sel->v.call.func->parmcount;
		args = sel->v.call.args;
		ptypes = sel->v.call.func->parmtype;
		rettype = sel->v.call.func->rettype;
		break;
	default:
		abort();
	}

	size = 2 + strlen(base_name) + 1 + strlen(nbuf) + 1;
	fname = emalloc(size);
	strcpy(fname, "$");
	strcat(fname, base_name);
	strcat(fname, "_");
	strcat(fname, nbuf);
	strcat(fname, "$");
	
	fp = function_lookup(fname);
	if (!fp) {
		/* Build and register the function */
		NODE *np, *catch_node;
		NODE *head, *tail;
		prog_counter_t pc;
		int i;
		struct function *save_func = func;
		int save_stie_in = stie_in;
		prog_counter_t save_jump_pc = jump_pc;
		
		/* Create the catch statement */
		np = alloc_node(node_type_catch, get_locus());
		np->v.catch.count = count;
		np->v.catch.exmask = 0;
		for (cur = cases; cur; cur = cur->next) {
			struct valist *vp;
			for (i = 0, vp = cur->valist;
			     vp; vp = vp->next, i++)
				np->v.catch.exmask |= EXMASK(vp->value.v.number);
		}
		
		catch_node = np;
		
		np = alloc_node(node_type_return, get_locus());
		np->v.node = alloc_node(node_type_arg, get_locus());
		np->v.node->v.number = 1;
		catch_node->v.catch.node = np;

		/* Build call arguments */
		head = tail = NULL;
		for (i = 1; i <= argc; i++) {
			np = alloc_node(node_type_arg, get_locus());
			np->v.number = i;
			if (!head)
				head = tail = np;
			else {
				tail->next = np;
				tail = np;
			}
		}
				     
		np = alloc_node(node_type_return, get_locus());
		np->v.node = sel; /* FIXME: create a copy */
		switch (np->v.node->type) {
		case node_type_builtin:
			np->v.node->v.builtin.args = head;
			break;
		case node_type_call:
			np->v.node->v.call.args = head;
			break;
		default:
			abort();
		}
		
		catch_node->next = np;
		
		fp = function_install(fname, argc, ptypes,
				      rettype,
				      get_locus());
		fp->exmask = mask;
		fp->node = catch_node;
		fp->entry = code_get_counter();
		
		/* Entry code */
		code_instr(instr_saveex);
		code_immediate((void*)fp->exmask);
		
		func = fp;
		stie_in = synt_function;
		jump_pc = 0;
		
		if (codegen(&pc, fp->node))
			error_count++;
		else {
			jump_fixup(jump_pc, code_get_counter());
			
			/* Exit code */
			code_instr(instr_restex);
			code_instr(instr_return);
		}
		func = save_func;
		stie_in = save_stie_in;
		jump_pc = save_jump_pc;
	}
	free(fname);
	
	call_node = alloc_node(node_type_call, get_locus());
	call_node->v.call.func = fp;
	call_node->v.call.args = args;
	
	retnode = alloc_node(node_type_switch, get_locus());
	retnode->v.switch_stmt.node = call_node;
	retnode->v.switch_stmt.cases = cases;

	return retnode;
}


